
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>linux常用命令加实例大全 / iVAN</title>

    <meta name="description" content="linux常用命令加实例大全 目  录引言    1一.安装和登录    2(一)    login    2(二)    shutdown    2(三)    halt    3(四)    reboot    3(五)    install    4(六)    mount    4(七)    umount    6(八)    chsh    6(九)    exit    7(十)    last    7(十一)    动手练习    7二.文件处理    9(一)    file    9(二)    mkd">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">linux常用命令加实例大全</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>目  录<br />引言    1<br />一、安装和登录    2<br />(一)    login    2<br />(二)    shutdown    2<br />(三)    halt    3<br />(四)    reboot    3<br />(五)    install    4<br />(六)    mount    4<br />(七)    umount    6<br />(八)    chsh    6<br />(九)    exit    7<br />(十)    last    7<br />(十一)    动手练习    7<br />二、文件处理    9<br />(一)    file    9<br />(二)    mkdir    9<br />(三)    grep    10<br />(四)    dd    11<br />(五)    find    11<br />(六)    mv    13<br />(七)    ls    13<br />(八)    diff    14<br />(九)    cmp    15<br />(十)    cat    15<br />(十一)    ln    16<br />(十二)    动手练习    16<br />三、系统管理    18<br />(一)    df    18<br />(二)    top    19<br />(三)    free    20<br />(四)    quota    20<br />(五)    at    21<br />(六)    lp    21<br />(七)    useradd    22<br />(八)    groupadd    23<br />(九)    kill    23<br />(十)    crontab    24<br />(十一)    动手练习    25<br />四、网络操作    27<br />(一)    ifconfig    27<br />(二)    ip    27<br />(三)    ping    28<br />(四)    netstat    29<br />(五)    telnet    30<br />(六)    ftp    31<br />(七)    route    32<br />(八)    rlogin    33<br />(九)    rcp    33<br />(十)    finger    34<br />(十一)    mail    34<br />(十二)    nslookup    34<br />(十三)    动手练习    35<br />五、系统安全    38<br />(一)    passwd    38<br />(二)    su    38<br />(三)    umask    39<br />(四)    chgrp    39<br />(五)    chmod    40<br />(六)    chown    41<br />(七)    chattr    42<br />(八)    sudo    43<br />(九)    ps    43<br />(十)    who    44<br />(十一)    动手练习    45<br />六、其他    47<br />(一)    tar    47<br />(二)    unzip    48<br />(三)    gunzip    49<br />(四)    unarj    50<br />(五)    mtools    50<br />(六)    man    51<br />(七)    unencode    53<br />(八)    uudecode    53<br />(九)    动手练习    53</p>
<p> <br />引言<br />Linux提供了大量的命令，利用它可以有效地完成大量的工作，如磁盘操作、文件存取、目录操作、进程管理、文件权限设定等。所以，在Linux系 统上工作离不开使用系统提供的命令。要想真正理解Linux系统，就必须从Linux命令学起，通过基础的命令学习可以进一步理解Linux系统。<br />不同Linux发行版的命令数量不一样，但Linux发行版本最少的命令也有200多个。这里笔者把比较重要和使用频率最多的命令，按照它们在系统中的作用分成下面六个部分一一介绍。<br />◆ 安装和登录命令：login、shutdown、halt、reboot、install、mount、umount、chsh、exit、last；<br />◆ 文件处理命令：file、mkdir、grep、dd、find、mv、ls、diff、cat、ln；<br />◆ 系统管理相关命令：df、top、free、quota、at、lp、adduser、groupadd、kill、crontab；<br />◆ 网络操作命令：ifconfig、ip、ping、netstat、telnet、ftp、route、rlogin、rcp、finger、mail、 nslookup；<br />◆ 系统安全相关命令：passwd、su、umask、chgrp、chmod、chown、chattr、sudo ps、who；<br />◆ 其它命令：tar、unzip、gunzip、unarj、mtools、man、unendcode、uudecode。</p>
<p> <br />一、安装和登录<br />本文以Mandrake Linux 9.1(Kenrel 2.4.21)为例，介绍Linux下的安装和登录命令。<br />(一)    login<br />1.作用<br />login的作用是登录系统，它的使用权限是所有用户。<br />2.格式<br />login [name][－p ][－h 主机名称]<br />3.主要参数<br />－p:通知login保持现在的环境参数。<br />－h:用来向远程登录的之间传输用户名。<br />如果选择用命令行模式登录Linux的话，那么看到的第一个Linux命令就是login：。<br />一般界面是这样的：<br />Manddrake Linux release 9.1(Bamboo) for i586<br />renrel 2.4.21－0.13mdk on i686 / tty1<br />localhost login:root<br />password:<br />上面代码中，第一行是Linux发行版本号，第二行是<a href="http://www.so.com/s?q=%E5%86%85%E6%A0%B8%E7%89%88%E6%9C%AC%E5%8F%B7&amp;ie=utf-8&amp;src=se_lighten_f" rel="external nofollow noreferrer">内核版本号</a>和登录的<a href="http://www.so.com/s?q=%E8%99%9A%E6%8B%9F%E6%8E%A7%E5%88%B6%E5%8F%B0&amp;ie=utf-8&amp;src=se_lighten_f" rel="external nofollow noreferrer">虚拟控制台</a>，我们在第三行输入登录名，按“Enter”键在Password后输入<a href="http://www.so.com/s?q=%E8%B4%A6%E6%88%B7%E5%AF%86%E7%A0%81&amp;ie=utf-8&amp;src=se_lighten_f" rel="external nofollow noreferrer">账户密码</a>，即可登录系统。出于安全考虑，输入账户密码时字符不会在屏幕上回显，光标也不移动。<br />登录后会看到下面这个界面（以超级用户为例）：<br />[root@localhost root]#<br />last login:Tue ,Nov 18 10:00:55 on vc/1<br />上面显示的是登录星期、月、日、时间和使用的虚拟控制台。<br />4.应用技巧<br />Linux是一个真正的多用户操作系统，可以同时接受多个用户登录，还允许一个用户进行多次登录。这是因为Linux和许多版本的Unix一样，提 供了虚拟控制台的访问方式，允许用户在同一时间从控制台（系统的控制台是与系统直接相连的监视器和键盘）进行多次登录。每个虚拟控制台可以看作是一个独立 的工作站，工作台之间可以切换。虚拟控制台的切换可以通过按下Alt键和一个功能键来实现，通常使用F1-F6 。<br />例如，用户登录后，按一下“Alt+F2”键，用户就可以看到上面出现的“login:”提示符，说明用户看到了第二个虚拟控制台。然后只需按 “Alt+ F1”键，就可以回到第一个虚拟控制台。一个新安装的Linux系统允许用户使用“Alt+F1”到“Alt+F6”键来访问前六个虚拟控制台。虚拟控制 台最有用的是，当一个程序出错造成系统死锁时，可以切换到其它虚拟控制台工作，关闭这个程序。<br />(二)    shutdown<br />1.作用<br />shutdown命令的作用是关闭计算机，它的使用权限是超级用户。<br />2.格式<br />shutdown [－h][－i][－k][－m][－t]<br />3.重要参数<br />－t：在改变到其它运行级别之前，告诉init程序多久以后关机。<br />－k：并不真正关机，只是送警告信号给每位登录者。<br />－h：关机后关闭电源。<br />－c：cancel current process取消目前正在执行的<a href="http://www.so.com/s?q=%E5%85%B3%E6%9C%BA%E7%A8%8B%E5%BA%8F&amp;ie=utf-8&amp;src=se_lighten_f" rel="external nofollow noreferrer">关机程序</a>。所以这个选项当然没有时间参数，但是可以输入一个用来解释的讯息，而这信息将会送到每位使用者。<br />－F：在重启计算机时强迫fsck。<br />－time：设定关机前的时间。<br />－m: 将系统改为单用户模式。<br />－i：关机时显示系统信息。<br />4.命令说明<br />shutdown命令可以安全地将<a href="http://www.so.com/s?q=%E7%B3%BB%E7%BB%9F%E5%85%B3%E6%9C%BA&amp;ie=utf-8&amp;src=se_lighten_f" rel="external nofollow noreferrer">系统关机</a>。有些用户会使用直接断掉电源的方式来关闭Linux系统，这是十分危险的。因为Linux与 Windows不同，其后台运行着许多进程，所以强制关机可能会导致进程的数据丢失，使系统处于不稳定的状态，甚至在有的系统中会损坏硬件设备（硬盘）。 在系统关机前使用 shutdown命令，系统管理员会通知所有登录的用户系统将要关闭，并且login指令会被冻结，即新的用户不能再登录。<br />(三)    halt<br />1.作用<br />halt命令的作用是关闭系统，它的使用权限是超级用户。<br />2.格式<br />halt [－n] [－w] [－d] [－f] [－i] [－p]<br />3.主要参数说明<br />－n：防止sync系统调用，它用在用fsck修补根分区之后，以阻止内核用老版本的超级块覆盖修补过的超级块。<br />－w：并不是真正的重启或关机,只是写wtmp（/var/log/wtmp）纪录。<br />－f：没有调用shutdown，而强制关机或重启。<br />－i：关机（或重启）前，关掉所有的网络接口。<br />－f：强迫关机，不呼叫shutdown这个指令。<br />－p: 当关机的时候顺便做关闭电源的动作。<br />－d：关闭系统，但不留下纪录。　<br />4.命令说明<br />halt就是调用shutdown －h。halt执行时，杀死应用进程，执行sync(将存于buffer中的资料强制写入硬盘中)系统调用，文件系统写操作完成后就会停止内核。若系统的 运行级别为0或6，则关闭系统；否则以shutdown指令（加上－h参数）来取代。　<br />(四)    reboot<br />1.作用<br />reboot命令的作用是重新启动计算机，它的使用权限是系统管理者。<br />2.格式<br />reboot [－n] [－w] [－d] [－f] [－i]<br />3.主要参数<br />－n: 在重开机前不做将记忆体资料写回硬盘的动作。<br />－w: 并不会真的重开机，只是把记录写到/var/log/wtmp文件里。<br />－d: 不把记录写到/var/log/wtmp文件里（－n这个参数包含了－d）。<br />－i: 在重开机之前先把所有与网络相关的装置停止。<br />(五)    install<br />1.作用<br />install命令的作用是安装或升级软件或备份数据，它的使用权限是所有用户。<br />2.格式<br />(1)install [选项]... 来源 目的地<br />(2)install [选项]... 来源... 目录<br />(3)install －d [选项]... 目录...<br />在前两种格式中，会将&lt;来源&gt;复制至&lt;目的地&gt;或将多个&lt;来源&gt;文件复制至已存在的&lt;目录&gt;，同 时设定权限模式及所有者/所属组。在第三种格式中，会创建所有指定的目录及它们的主目录。长选项必须用的参数在使用短选项时也是必须的。<br />3.主要参数<br />－－backup[=CONTROL]：为每个已存在的目的地文件进行备份。<br />－b：类似 －－backup，但不接受任何参数。<br />－c：(此选项不作处理)。<br />－d，－－directory：所有参数都作为目录处理，而且会创建指定目录的所有主目录。<br />－D：创建&lt;目的地&gt;前的所有主目录，然后将&lt;来源&gt;复制至 &lt;目的地&gt;；在第一种使用格式中有用。<br />－g，－－group=组：自行设定所属组，而不是进程目前的所属组。<br />－m，－－mode=模式：自行设定权限模式 (像chmod)，而不是rwxr－xr－x。<br />－o，－－owner=所有者：自行设定所有者 (只适用于超级用户)。<br />－p，－－preserve－timestamps：以&lt;来源&gt;文件的访问/修改时间作为相应的目的地文件的时间属性。<br />－s，－－strip：用strip命令删除symbol table，只适用于第一及第二种使用格式。<br />－S，－－suffix=后缀：自行指定备份文件的&lt;后缀&gt;。<br />－v，－－verbose：处理每个文件/目录时印出名称。<br />－－help：显示此帮助信息并离开。<br />－－version：显示版本信息并离开。<br />(六)    mount<br />1.作用<br />mount命令的作用是加载文件系统，其使用权限是超级用户或/etc/fstab中允许的使用者。<br />2.格式<br />mount －a [－fv] [－t vfstype] [－n] [－rw] [－F] device dir<br />3.主要参数<br />－h：显示辅助信息。<br />－v：显示信息，通常和－f用来除错。<br />－a：将/etc/fstab中定义的所有文件系统挂上。<br />－F：这个命令通常和－a一起使用，它会为每一个mount的动作产生一个行程负责执行。在系统需要挂上大量NFS文件系统时可以加快加载的速度。<br />－f：通常用于除错。它会使mount不执行实际挂上的动作，而是模拟整个挂上的过程，通常会和－v一起使用。<br />－t vfstype：显示被加载文件系统的类型。<br />－n：一般而言，mount挂上后会在/etc/mtab中写入一笔资料，在系统中没有可写入文件系统的情况下，可以用这个选项取消这个动作。<br />4.应用技巧<br />在Linux和Unix系统上，所有文件都是作为一个大型树（以/为根）的一部分访问的。要访问CD-ROM上的文件，需要将CD-ROM设备挂装 在文件树中的某个挂装点。如果发行版安装了自动挂装包，那么这个步骤可自动进行。在Linux中，如果要使用硬盘、光驱等储存设备，就得先将它加载，当储存设备挂上了之后，就可以把它当成一个目录来访问。挂上一个设备使用mount命令。在使用mount这个指令时，至少要先知道下列三种信息：要加载对象 的文件系统类型、要加载对象的设备名称及要将设备加载到哪个目录下。<br />（1）Linux可以识别的文件系统<br />◆ Windows 95/98常用的FAT 32文件系统：vfat ；<br />◆ Win NT/2000 的文件系统：ntfs ；<br />◆ OS/2用的文件系统：hpfs；<br />◆ Linux用的文件系统：ext2、ext3；<br />◆ CD-ROM光盘用的文件系统：iso9660。<br />虽然vfat是指FAT 32系统，但事实上它也兼容FAT 16的文件系统类型。<br />（2）确定设备的名称<br />在Linux中，设备名称通常都存在/dev里。这些设备名称的命名都是有规则的，可以用“推理”的方式把设备名称找出来。例如，/dev /hda1这个 IDE设备，hd是Hard Disk(硬盘)的，sd是SCSI Device，fd是Floppy Device(或是Floppy Disk?)。a代表第一个设备，通常IDE接口可以接上4个IDE设备(比如4块硬盘)。所以要识别IDE硬盘的方法分别就是hda、hdb、hdc、 hdd。hda1中的“1”代表hda的第一个硬盘分区 (partition)，hda2代表hda的第二主分区，第一个逻辑分区从hda5开始，依此类推。此外，可以直接检查/var/log /messages文件，在该文件中可以找到计算机开机后系统已辨认出来的设备代号。<br />（3）查找挂接点<br />在决定将设备挂接之前，先要查看一下计算机是不是有个/mnt的空目录，该目录就是专门用来当作挂载点(Mount Point)的目录。建议在/mnt里建几个/mnt/cdrom、/mnt/floppy、/mnt/mo等目录，当作目录的专用挂载点。举例而言，如要挂载下列5个设备，其执行指令可能如下 (假设都是Linux的ext2系统，如果是Windows XX请将ext2改成vfat)：<br />软盘 ===&gt;mount －t ext2 /dev/fd0 /mnt/floppy<br />cdrom ===&gt;mount －t iso9660 /dev/hdc /mnt/cdrom<br />SCSI cdrom ===&gt;mount －t iso9660 /dev/sdb /mnt/scdrom<br />SCSI cdr ===&gt;mount －t iso9660 /dev/sdc /mnt/scdr<br />不过目前大多数较新的Linux发行版本（包括红旗 Linux、中软Linux、Mandrake Linux等）都可以自动挂装文件系统，但Red Hat Linux除外。<br />(七)    umount<br />1.作用<br />umount命令的作用是卸载一个文件系统，它的使用权限是超级用户或/etc/fstab中允许的使用者。<br />2.格式<br />unmount －a [－fFnrsvw] [－t vfstype] [－n] [－rw] [－F] device dir<br />3.使用说明<br />umount命令是mount命令的逆操作，它的参数和使用方法和mount命令是一样的。Linux挂装CD-ROM后，会锁定CD—ROM，这 样就不能用CD-ROM面板上的Eject按钮弹出它。但是，当不再需要光盘时，如果已将/cdrom作为符号链接，请使用umount/cdrom来卸 装它。仅当无用户正在使用光盘时，该命令才会成功。该命令包括了将带有当前工作目录当作该光盘中的目录的终端窗口。<br />(八)    chsh<br />1.作用<br />chsh命令的作用是更改使用者shell设定，它的使用权限是所有使用者。<br />2.格式<br />chsh [ －s ] [ －list] [ －－help ] [ －v ] [ username ]<br />3.主要参数<br />－l：显示系统所有Shell类型。<br />－v：显示Shell版本号。<br />4.应用技巧<br />前面介绍了Linux下有多种Shell，一般缺省的是Bash，如果想更换Shell类型可以使用chsh命令。先输入账户密码，然后输入新Shell类型，如果操作正确系统会显示“Shell change”。其界面一般如下：<br />Changing fihanging shell for cao<br />Password:<br />New shell [/bin/bash]: /bin/tcsh<br />上面代码中，[ ]内是目前使用的Shell。普通用户只能修改自己的Shell，超级用户可以修改全体用户的Shell。要想查询系统提供哪些Shell，可以使用chsh -l 命令，见图1所示。<br /> <br />图1 系统可以使用的Shell类型<br />从图1中可以看到，笔者系统中可以使用的Shell有bash（缺省）、csh、sh、tcsh四种。<br />(九)    exit<br />1.作用<br />exit命令的作用是退出系统，它的使用权限是所有用户。<br />2.格式<br />exit<br />3.参数<br />exit命令没有参数，运行后退出系统进入登录界面。<br />(十)    last<br />1.作用<br />last命令的作用是显示近期用户或终端的登录情况，它的使用权限是所有用户。通过last命令查看该程序的log，管理员可以获知谁曾经或企图连接系统。<br />2.格式<br />1ast[—n][－f file][－t tty] [—h 节点][－I —IP][—1][－y][1D]<br />3.主要参数<br />－n：指定输出记录的条数。<br />－f file：指定用文件file作为查询用的log文件。<br />－t tty：只显示指定的虚拟控制台上登录情况。<br />－h 节点：只显示指定的节点上的登录情况。<br />－i IP：只显示指定的IP上登录的情况。<br />－1：用IP来显示远端地址。<br />－y：显示记录的年、月、日。<br />－ID：知道查询的用户名。<br />－x:显示系统关闭、用户登录和退出的历史。<br />(十一)    动手练习<br />上面介绍了Linux安装和登录命令，下面介绍几个实例，动手练习一下刚才讲过的命令。<br />1.一次运行多个命令<br />在一个命令行中可以执行多个命令，用分号将各个命令隔开即可，例如：<br />＃last －x；halt<br />上面代码表示在显示系统关闭、用户登录和退出的历史后关闭计算机。<br />2.利用mount挂装文件系统访问Windows系统<br />许多Linux发行版本现在都可以自动加载Vfat分区来访问Windows系统，而Red Hat各个版本都没有自动加载Vfat分区，因此还需要进行手工操作。<br />mount可以将Windows分区作为Linux的一个“文件”挂接到Linux的一个空文件夹下，从而将Windows的分区和/mnt这个目 录联系起来。因此，只要访问这个文件夹就相当于访问该分区了。首先要在/mnt下建立winc文件夹，在命令提示符下输入下面命令：<br />＃mount -t vfat /dev/hda1 /mnt/winc<br />即表示将Windows的C分区挂到Liunx的/mnt/winc目录下。这时，在/mnt/winc目录下就可以看到Windows中C盘的内 容了。使用类似的方法可以访问Windows系统的D、E盘。在Linux系统显示Windows的分区一般顺序这样的：hda1为C盘、hda5为D 盘、 hda6为E盘……以此类推。上述方法可以查看Windows系统有一个很大的问题，就是Windows中的所有中文文件名或文件夹名全部显示为问号 “？”，而英文却可以正常显示。我们可以通过加入一些参数让它显示中文。还以上面的操作为例，此时输入命令：<br />＃mount -t vfat -o iocharset=cp936 /dev/hda1 /mnt/winc<br />现在它就可以正常显示中文了。<br />3.使用mount加挂闪盘上的文件系统<br />在Linux下使用闪盘非常简单。Linux对USB设备有很好的支持，当插入闪盘后，闪盘被识别为一个SCSI盘，通常输入以下命令：<br />＃ mount /dev/sda1 /usb<br />就能够加挂闪盘上的文件系统。<br />(十二)    小知识<br />Linux命令与Shell<br />所谓Shell，就是命令解释程序，它提供了程序设计接口，可以使用程序来编程。学习Shell对于Linux初学者理解Linux系统是非常重要 的。 Linux系统的Shell作为操作系统的外壳，为用户提供了使用操作系统的接口。Shell是命令语言、命令解释程序及程序设计语言的统称，是用户和 Linux内核之间的接口程序。如果把Linux内核想象成一个球体的中心，Shell就是围绕内核的外层。当从Shell或其它程序向Linux传递命令时，内核会做出相应的反应。Shell在Linux系统的作用和MS DOS下的COMMAND.COM和Windows 95/98 的 explorer.exe相似。Shell虽然不是系统核心的一部分，只是系统核心的一个外延，但它能够调用系统内核的大部分功能。因此，可以说 Shell是Unux/Linux最重要的实用程序。<br />Linux中的Shell有多种类型，其中最常用的是Bourne Shell(sh)、C Shell(csh)和Korn Shell(ksh)。大多数Linux发行版本缺省的Shell是Bourne Again Shell，它是Bourne Shell的扩展，简称bash，与Bourne Shell完全向后兼容，并且在Bourne Shell的基础上增加了很多特性。bash放在/bin/bash中，可以提供如命令补全、命令编辑和命令历史表等功能。它还包含了很多C Shell和Korn Shell中的优点，有灵活和强大的编程接口，同时又有很友好的用户界面。Linux系统中200多个命令中有40个是bash的内部命令，主要包括 exit、less、lp、kill、 cd、pwd、fc、fg等。</p>
<p> <br />二、文件处理<br />Linux 系统信息存放在文件里，文件与普通的公务文件类似。每个文件都有自己的名字、内容、存放地址及其它一些管理信息，如文件的用户、文件的大小等。文件可以是一封信、一个通讯录，或者是程序的源语句、程序的数据，甚至可以包括可执行的程序和其它非正文内容。 Linux文件系统具有良好的结构，系统提供了很多文件处理程序。这里主要介绍常用的文件处理命令。<br />(一)    file<br />1.作用<br />根据文件内容判断文件类型，使用权限是所有用户。<br />2.格式<br />file通过探测文<br />file [options] 文件名<br />3.[options]主要参数<br />-v：在标准输出后显示版本信息，并且退出。<br />-z：探测压缩过的文件类型。<br />-L：允许符合连接。<br />-f name：从文件namefile中读取要分析的文件名列表。<br />4.简单说明<br />使用file命令可以知道某个文件究竟是二进制（ELF格式）的可执行文件, 还是Shell Script文件，或者是其它的什么格式。file能识别的文件类型有目录、Shell脚本、英文文本、二进制可执行文件、C语言源文件、文本文件、DOS的可执行文件。<br />5.应用实例<br />如果我们看到一个没有后缀的文件grap，可以使用下面命令：<br />$ file grap<br />grap： English text<br />此时系统显示这是一个英文文本文件。需要说明的是，file命令不能探测包括图形、音频、视频等多媒体文件类型。<br />(二)    mkdir<br />1.作用<br />mkdir命令的作用是建立名称为dirname的子目录，与MS DOS下的md命令类似，它的使用权限是所有用户。<br />2.格式<br />mkdir [options] 目录名<br />3.[options]主要参数<br />－m, －－mode=模式：设定权限&lt;模式&gt;，与chmod类似。<br />－p, －－parents：需要时创建上层目录；如果目录早已存在，则不当作错误。<br />－v, －－verbose：每次创建新目录都显示信息。<br />－－version：显示版本信息后离开。<br />4.应用实例<br />在进行目录创建时可以设置目录的权限，此时使用的参数是“－m”。假设要创建的目录名是“tsk”，让所有用户都有rwx(即读、写、执行的权限)，那么可以使用以下命令：<br />$ mkdir －m 777 tsk<br />(三)    grep<br />1.作用<br />grep命令可以指定文件中搜索特定的内容，并将含有这些内容的行标准输出。grep全称是Global Regular Expression Print，表示全局正则表达式版本，它的使用权限是所有用户。<br />2.格式<br />grep [options]<br />3.主要参数<br />[options]主要参数：<br />－c：只输出匹配行的计数。<br />－I：不区分大小写（只适用于单字符）。<br />－h：查询多文件时不显示文件名。<br />－l：查询多文件时只输出包含匹配字符的文件名。<br />－n：显示匹配行及行号。<br />－s：不显示不存在或无匹配文本的错误信息。<br />－v：显示不包含匹配文本的所有行。<br />pattern正则表达式主要参数：<br />\：忽略正则表达式中特殊字符的原有含义。<br />^：匹配正则表达式的开始行。<br />$: 匹配正则表达式的结束行。<br />\&lt;：从匹配正则表达式的行开始。<br />\&gt;：到匹配正则表达式的行结束。<br />[ ]：单个字符，如[A]即A符合要求 。<br />[ - ]：范围，如[A-Z]，即A、B、C一直到Z都符合要求 。<br />. ：所有的单个字符。<br />* ：有字符，长度可以为0。<br />正则表达式是Linux/Unix系统中非常重要的概念。正则表达式（也称为“regex”或“regexp”）是一个可以描述一类字符串的模式 （Pattern）。如果一个字符串可以用某个正则表达式来描述，我们就说这个字符和该正则表达式匹配（Match）。这和DOS中用户可以使用通配符 “*”代表任意字符类似。在Linux系统上，正则表达式通常被用来查找文本的模式，以及对文本执行“搜索－替换”操作和其它功能。<br />4.应用实例<br />查询DNS服务是日常工作之一，这意味着要维护覆盖不同网络的大量IP地址。有时IP地址会超过2000个。如果要查看nnn.nnn网络地址，但 是却忘了第二部分中的其余部分，只知到有两个句点，例如nnn nn..。要抽取其中所有nnn.nnn IP地址，使用[0－9 ]\{3 \}\.[0－0\{3\}\。含义是任意数字出现3次，后跟句点，接着是任意数字出现3次，后跟句点。<br />$grep '[0－9 ]\{3 \}\.[0－0\{3\}\' ipfile<br />补充说明，grep家族还包括fgrep和egrep。fgrep是fix grep，允许查找字符串而不是一个模式；egrep是扩展grep，支持基本及扩展的正则表达式，但不支持\q模式范围的应用及与之相对应的一些更加规范的模式。<br />(四)    dd<br />1.作用<br />dd命令用来复制文件，并根据参数将数据转换和格式化。<br />2.格式<br />dd [options]<br />3.[opitions]主要参数<br />bs=字节：强迫 ibs=&lt;字节&gt;及obs=&lt;字节&gt;。<br />cbs=字节：每次转换指定的&lt;字节&gt;。<br />conv=关键字：根据以逗号分隔的关键字表示的方式来转换文件。<br />count=块数目：只复制指定&lt;块数目&gt;的输入数据。<br />ibs=字节：每次读取指定的&lt;字节&gt;。<br />if=文件：读取&lt;文件&gt;内容，而非标准输入的数据。<br />obs=字节：每次写入指定的&lt;字节&gt;。<br />of=文件：将数据写入&lt;文件&gt;，而不在标准输出显示。<br />seek=块数目：先略过以obs为单位的指定&lt;块数目&gt;的输出数据。<br />skip=块数目：先略过以ibs为单位的指定&lt;块数目&gt;的输入数据。<br />4.应用实例<br />dd命令常常用来制作Linux启动盘。先找一个可引导内核，令它的根设备指向正确的根分区，然后使用dd命令将其写入软盘：<br />$ rdev vmlinuz /dev/hda<br />$dd if＝vmlinuz of＝/dev/fd0<br />上面代码说明，使用rdev命令将可引导内核vmlinuz中的根设备指向/dev/hda，请把“hda”换成自己的根分区，接下来用dd命令将该内核写入软盘。<br />(五)    find<br />1.作用<br />find命令的作用是在目录中搜索文件，它的使用权限是所有用户。<br />2.格式<br />find [path][options][expression]<br />path指定目录路径，系统从这里开始沿着目录树向下查找文件。它是一个路径列表，相互用空格分离，如果不写path，那么默认为当前目录。<br />3.主要参数<br />[options]参数：<br />－depth：使用深度级别的查找过程方式，在某层指定目录中优先查找文件内容。<br />－maxdepth levels：表示至多查找到开始目录的第level层子目录。level是一个非负数，如果level是0的话表示仅在当前目录中查找。<br />－mindepth levels：表示至少查找到开始目录的第level层子目录。<br />－mount：不在其它文件系统（如Msdos、Vfat等）的目录和文件中查找。<br />－version：打印版本。<br />[expression]是匹配表达式，是find命令接受的表达式，find命令的所有操作都是针对表达式的。它的参数非常多，这里只介绍一些常用的参数。<br />—name：支持统配符*和?。<br />－atime n：搜索在过去n天读取过的文件。<br />－ctime n：搜索在过去n天修改过的文件。<br />－group grpoupname：搜索所有组为grpoupname的文件。<br />－user 用户名：搜索所有文件属主为用户名（ID或名称）的文件。<br />－size n：搜索文件大小是n个block的文件。<br />－print：输出搜索结果，并且打印。<br />4.应用技巧<br />find命令查找文件的几种方法：<br />（1）根据文件名查找<br />例如，我们想要查找一个文件名是lilo.conf的文件，可以使用如下命令：<br />find / －name lilo.conf<br />find命令后的“/”表示搜索整个硬盘。<br />（2）快速查找文件<br />根据文件名查找文件会遇到一个实际问题，就是要花费相当长的一段时间，特别是大型Linux文件系统和大容量硬盘文件放在很深的子目录中时。如果我 们知道了这个文件存放在某个目录中，那么只要在这个目录中往下寻找就能节省很多时间。比如smb.conf文件，从它的文件后缀“.conf”可以判断这 是一个配置文件，那么它应该在/etc目录内，此时可以使用下面命令：<br />find /etc －name smb.conf<br />这样，使用“快速查找文件”方式可以缩短时间。<br />（3）根据部分文件名查找方法<br />有时我们知道只某个文件包含有abvd这4个字，那么要查找系统中所有包含有这4个字符的文件可以输入下面命令：<br />find / －name '*abvd*'<br />输入这个命令以后，Linux系统会将在/目录中查找所有的包含有abvd这4个字符的文件（其中*是通配符），比如abvdrmyz等符合条件的文件都能显示出来。<br />(4) 使用混合查找方式查找文件<br />find命令可以使用混合查找的方法，例如，我们想在/etc目录中查找大于500000字节，并且在24小时内修改的某个文件，则可以使用-and (与)把两个查找参数链接起来组合成一个混合的查找方式。<br />find /etc -size +500000c -and -mtime +1<br />(六)    mv<br />1.作用<br />mv命令用来为文件或目录改名，或者将文件由一个目录移入另一个目录中，它的使用权限是所有用户。该命令如同DOS命令中的ren和move的组合。<br />2.格式<br />mv[options] 源文件或目录 目标文件或目录<br />3.[options]主要参数<br />－i：交互方式操作。如果mv操作将导致对已存在的目标文件的覆盖，此时系统询问是否重写，要求用户回答“y”或“n”，这样可以避免误覆盖文件。<br />－f：禁止交互操作。mv操作要覆盖某个已有的目标文件时不给任何指示，指定此参数后i参数将不再起作用。<br />4.应用实例<br />（1）将/usr/cbu中的所有文件移到当前目录（用“.”表示）中：<br />$ mv /usr/cbu/ * .<br />（2）将文件cjh.txt重命名为wjz.txt：<br />$ mv cjh.txt wjz.txt<br />(七)    ls<br />1.作用<br />ls命令用于显示目录内容，类似DOS下的dir命令，它的使用权限是所有用户。<br />2.格式<br />ls [options][filename]<br />3.options主要参数<br />－a, －－all：不隐藏任何以“.” 字符开始的项目。<br />－A, －－almost－all：列出除了“ . ”及 “.. ”以外的任何项目。<br />－－author：印出每个文件著作者。<br />－b, －－escape：以八进制溢出序列表示不可打印的字符。<br />－－block－size=大小：块以指定&lt;大小&gt;的字节为单位。<br />－B, －－ignore－backups：不列出任何以 ~ 字符结束的项目。<br />－f：不进行排序，－aU参数生效，－lst参数失效。<br />－F, －－classify：加上文件类型的指示符号 (*/=@| 其中一个)。<br />－g：like －l, but do not list owner。<br />－G, －－no－group：inhibit display of group information。<br />－i, －－inode：列出每个文件的inode号。<br />－I, －－ignore=样式：不印出任何符合Shell万用字符&lt;样式&gt;的项目。<br />－k：即－－block－size=1K。<br />－l：使用较长格式列出信息。<br />－L, －－dereference：当显示符号链接的文件信息时，显示符号链接所指示的对象，而并非符号链接本身的信息。<br />－m：所有项目以逗号分隔，并填满整行行宽。<br />－n, －－numeric－uid－gid：类似－l，但列出UID及GID号。<br />－N, －－literal：列出未经处理的项目名称，例如不特别处理控制字符。<br />－p, －－file－type：加上文件类型的指示符号 (/=@| 其中一个)。<br />－Q, －－quote－name：将项目名称括上双引号。<br />－r, －－reverse：依相反次序排列。<br />－R, －－recursive：同时列出所有子目录层。<br />－s, －－size：以块大小为序。<br />4.应用举例<br />ls 命令是Linux系统使用频率最多的命令，它的参数也是Linux命令中最多的。使用ls命令时会有几种不同的颜色，其中蓝色表示是目录，绿色表示是可执 行文件，红色表示是压缩文件，浅蓝色表示是链接文件，加粗的黑色表示符号链接，灰色表示是其它格式文件。ls最常使用的是ls- l，见图1所示。<br /> <br />图1 使用ls-l命令<br />文件类型开头是由10个字符构成的字符串。其中第一个字符表示文件类型，它可以是下述类型之一：－（普通文件）、d（目录）、l（符号链接）、 b（块设备文件）、c（字符设备文件）。后面的9个字符表示文件的访问权限，分为3组，每组3位。第一组表示文件属主的权限，第二组表示同组用户的权限， 第三组表示其他用户的权限。每一组的三个字符分别表示对文件的读（r）、写（w）和执行权限（x）。对于目录，表示进入权限。s表示当文件被执行时，把该 文件的UID 或GID赋予执行进程的UID（用户ID）或GID（组 ID）。t表示设置标志位（留在内存，不被换出）。如果该文件是目录，那么在该目录中的文件只能被超级用户、目录拥有者或文件属主删除。如果它是可执行文 件，那么在该文件执行后，指向其正文段的指针仍留在内存。这样再次执行它时，系统就能更快地装入该文件。接着显示的是文件大小、生成时间、文件或命令名 称。<br />(八)    diff<br />1.作用<br />diff命令用于两个文件之间的比较，并指出两者的不同，它的使用权限是所有用户。<br />2.格式<br />diff [options] 源文件 目标文件<br />3.[options]主要参数<br />-a：将所有文件当作文本文件来处理。<br />-b：忽略空格造成的不同。<br />-B：忽略空行造成的不同。<br />-c：使用纲要输出格式。<br />-H：利用试探法加速对大文件的搜索。<br />-I：忽略大小写的变化。<br />-n --rcs：输出RCS格式。<br />(九)    cmp<br />1.作用<br />cmp（“compare”的缩写）命令用来简要指出两个文件是否存在差异，它的使用权限是所有用户。<br />2.格式<br />cmp[options] 文件名<br />3.[options]主要参数<br />-l: 将字节以十进制的方式输出，并方便将两个文件中不同的以八进制的方式输出。<br />(十)    cat<br />1.作用<br />cat（“concatenate”的缩写）命令用于连接并显示指定的一个和多个文件的有关信息，它的使用权限是所有用户。<br />2.格式<br />cat [options] 文件1 文件2……<br />3.[options]主要参数<br />－n：由第一行开始对所有输出的行数编号。<br />－b：和－n相似，只不过对于空白行不编号。<br />－s：当遇到有连续两行以上的空白行时，就代换为一行的空白行。<br />4.应用举例<br />（1）cat命令一个最简单的用处是显示文本文件的内容。例如，我们想在命令行看一下README文件的内容，可以使用命令：<br />$ cat README　<br />（2）有时需要将几个文件处理成一个文件，并将这种处理的结果保存到一个单独的输出文件。cat命令在其输入上接受一个或多个文件，并将它们作为一 个单独的文件打印到它的输出。例如，把README和INSTALL的文件内容加上行号（空白行不加）之后，将内容附加到一个新文本文件File1 中：<br />$ cat README INSTALL File1<br />（3）cat还有一个重要的功能就是可以对行进行编号，见图2所示。这种功能对于程序文档的编制，以及法律和科学文档的编制很方便，打印在左边的行号使得参考文档的某一部分变得容易，这些在编程、科学研究、业务报告甚至是立法工作中都是非常重要的。<br /> <br />图2 使用cat命令/etc/named.conf文件进行编号<br />对行进行编号功能有-b（只能对非空白行进行编号）和-n（可以对所有行进行编号）两个参数：<br />$ cat -b /etc/named.conf<br />(十一)    ln<br />1.作用<br />ln命令用来在文件之间创建链接，它的使用权限是所有用户。<br />2.格式<br />ln [options] 源文件 [链接名]<br />3.参数<br />－f：链结时先将源文件删除。<br />－d：允许系统管理者硬链结自己的目录。<br />－s：进行软链结(Symbolic Link)。<br />－b：将在链结时会被覆盖或删除的文件进行备份。<br />链接有两种，一种被称为硬链接（Hard Link），另一种被称为符号链接（Symbolic Link）。默认情况下，ln命令产生硬链接。<br />硬连接指通过索引节点来进行的连接。在Linux的文件系统中，保存在磁盘分区中的文件不管是什么类型都给它分配一个编号，称为索引节点号 (Inode Index)。在Linux中，多个文件名指向同一索引节点是存在的。一般这种连接就是硬连接。硬连接的作用是允许一个文件拥有多个有效路径名，这样用户 就可以建立硬连接到重要文件，以防止“误删”的功能。其原因如上所述，因为对应该目录的索引节点有一个以上的连接。只删除一个连接并不影响索引节点本身和 其它的连接，只有当最后一个连接被删除后，文件的数据块及目录的连接才会被释放。也就是说，文件才会被真正删除。<br />与硬连接相对应，Lnux系统中还存在另一种连接，称为符号连接（Symbilc Link），也叫软连接。软链接文件有点类似于Windows的快捷方式。它实际上是特殊文件的一种。在符号连接中，文件实际上是一个文本文件，其中包含的有另一文件的位置信息。<br />(十二)    动手练习<br />上面我们介绍了Linux文件处理命令，下面介绍几个实例，大家可以动手练习一下刚才讲过的命令。<br />1.利用符号链接快速访问关键目录<br />符号链接是一个非常实用的功能。假设有一些目录或文件需要频繁使用，但由于Linux的文件和目录结构等原因，这个文件或目录在很深的子目录中。比 如， Apache Web服务器文档位于系统的/usr/local/httpd/htdocs中，并且不想每次都要从主目录进入这样一个长的路径之中(实际上，这个路径也 非常不容易记忆)。<br />为了解决这个问题，可以在主目录中创建一个符号链接，这样在需要进入该目录时，只需进入这个链接即可。<br />为了能方便地进入Web服务器(/usr/local/httpd/htdocs)文档所在的目录，在主目录下可以使用以下命令：<br />$ ln -s /usr/local/httpd/htdocs gg<br />这样每次进入gg目录就可访问Web服务器的文档，以后如果不再访问Web服务器的文档时，删除gg即可，而真正的Web服务器的文档并没有删除。<br />2.使用dd命令将init.rd格式的root.ram内容导入内存<br />dd if=/dev/fd0 of=floppy.fd<br />dd if=root.ram of=/dev/ram0 #<br />3.grep命令系统调用<br />grep是Linux/Unix中使用最广泛的命令之一，许多Linux系统内部都可以调用它。<br />(1)如果要查询目录列表中的目录，方法如下：<br />$ ls -l | grep '∧d'<br />(2)如果在一个目录中查询不包含目录的所有文件，方法如下：<br />$ ls -l | grep '∧[∧d]'<br />(3)用find命令调用grep，如所有C源代码中的“Chinput”，方法如下：<br />$find /ZhXwin -name *.c -exec grep -q -s Chinput {} \;-print</p>
<p> <br />三、系统管理<br />对于Linux系统来说，无论是中央处理器、内存、磁盘驱动器、键盘、鼠标，还是用户等都是文件，Linux系统管理的命令是它正常运行的核心。熟悉了Linux常用的文件处理命令以后，这一讲介绍对系统和用户进行管理的命令。<br />(一)    df<br />1.作用<br />df命令用来检查文件系统的磁盘空间占用情况，使用权限是所有用户。<br />2.格式<br />df [options]<br />3.主要参数<br />－s：对每个Names参数只给出占用的数据块总数。<br />－a：递归地显示指定目录中各文件及子目录中各文件占用的数据块数。若既不指定－s，也不指定－a，则只显示Names中的每一个目录及其中的各子目录所占的磁盘块数。<br />－k：以1024字节为单位列出磁盘空间使用情况。<br />－x：跳过在不同文件系统上的目录不予统计。<br />－l：计算所有的文件大小，对硬链接文件则计算多次。<br />－i：显示inode信息而非块使用量。<br />－h：以容易理解的格式印出文件系统大小，例如136KB、254MB、21GB。<br />－P：使用POSIX输出格式。<br />－T：显示文件系统类型。<br />4.说明<br />df命令被广泛地用来生成文件系统的使用统计数据，它能显示系统中所有的文件系统的信息，包括总容量、可用的空闲空间、目前的安装点等。<br />超级权限用户使用df命令时会发现这样的情况：某个分区的容量超过了100％。这是因为Linux系统为超级用户保留了10％的空间，由其单独支 配。也就是说，对于超级用户而言，他所见到的硬盘容量将是110％。这样的安排对于系统管理而言是有好处的，当硬盘被使用的容量接近100％时系统管理员 还可以正常工作。<br />5.应用实例<br />Linux支持的文件系统非常多，包括JFS、ReiserFS、ext、ext2、ext3、ISO9660、XFS、Minx、vfat、MSDOS等。使用df -T命令查看磁盘空间时还可以得到文件系统的信息：<br />＃df －T<br />文件系统 类型 容量 已用 可用 已用% 挂载点<br />/dev/hda7 reiserfs 5.2G 1.6G 3.7G 30% /<br />/dev/hda1 vfat 2.4G 1.6G 827M 66% /windows/C<br />/dev/hda5 vfat 3.0G 1.7G 1.3G 57% /windows/D<br />/dev/hda9 vfat 3.0G 2.4G 566M 82% /windows/E<br />/dev/hda10 NTFS 3.2G 573M 2.6G 18% /windows/F<br />/dev/hda11 vfat 1.6G 1.5G 23M 99% /windows/G<br />从上面除了可以看到磁盘空间的容量、使用情况外，分区的文件系统类型、挂载点等信息也一览无遗。<br />(二)    top<br />1.作用<br />top命令用来显示执行中的程序进程，使用权限是所有用户。<br />2.格式<br />top [－] [d delay] [q] [c] [S] [s] [i] [n]<br />3.主要参数<br />d：指定更新的间隔，以秒计算。<br />q：没有任何延迟的更新。如果使用者有超级用户，则top命令将会以最高的优先序执行。<br />c：显示进程完整的路径与名称。<br />S：累积模式，会将己完成或消失的子行程的CPU时间累积起来。<br />s：安全模式。<br />i：不显示任何闲置(Idle)或无用(Zombie)的行程。<br />n：显示更新的次数，完成后将会退出top。<br />4.说明<br />top命令是Linux系统管理的一个主要命令，通过它可以获得许多信息。这里我们结合图1来说明它给出的信息。<br />图1 top命令的显示<br />在图1中，第一行表示的项目依次为当前时间、系统启动时间、当前系统登录用户数目、平均负载。第二行显示的是所有启动的进程、目前运行的、挂起 (Sleeping)的和无用(Zombie)的进程。第三行显示的是目前CPU的使用情况，包括系统占用的比例、用户使用比例、闲置(Idle)比例。 第四行显示物理内存的使用情况，包括总的可以使用的内存、已用内存、空闲内存、缓冲区占用的内存。第五行显示交换分区使用情况，包括总的交换分区、使用 的、空闲的和用于高速缓存的大小。第六行显示的项目最多，下面列出了详细解释。<br />PID（Process ID）：进程标示号。<br />USER：进程所有者的用户名。<br />PR：进程的优先级别。<br />NI：进程的优先级别数值。<br />VIRT：进程占用的虚拟内存值。<br />RES：进程占用的物理内存值。<br />SHR：进程使用的共享内存值。<br />S：进程的状态，其中S表示休眠，R表示正在运行，Z表示僵死状态，N表示该进程优先值是负数。<br />%CPU：该进程占用的CPU使用率。<br />%MEM：该进程占用的物理内存和总内存的百分比。<br />TIME＋：该进程启动后占用的总的CPU时间。<br />Command：进程启动的启动命令名称，如果这一行显示不下，进程会有一个完整的命令行。<br />top命令使用过程中，还可以使用一些交互的命令来完成其它参数的功能。这些命令是通过快捷键启动的。<br />&lt;空格&gt;：立刻刷新。<br />P：根据CPU使用大小进行排序。<br />T：根据时间、累计时间排序。<br />q：退出top命令。<br />m：切换显示内存信息。<br />t：切换显示进程和CPU状态信息。<br />c：切换显示命令名称和完整命令行。<br />M：根据使用内存大小进行排序。<br />W：将当前设置写入~/.toprc文件中。这是写top配置文件的推荐方法。<br />可以看到，top命令是一个功能十分强大的监控系统的工具，对于系统管理员而言尤其重要。但是，它的缺点是会消耗很多系统资源。<br />5.应用实例<br />使用top命令可以监视指定用户，缺省情况是监视所有用户的进程。如果想查看指定用户的情况，在终端中按“U”键，然后输入用户名，系统就会切换为指定用户的进程运行界面，见图2所示。<br />图2 使用top命令监视指定用户<br />(三)    free<br />1.作用<br />free命令用来显示内存的使用情况，使用权限是所有用户。<br />2.格式<br />free [－b|－k|－m] [－o] [－s delay] [－t] [－V]<br />3.主要参数<br />－b －k －m：分别以字节（KB、MB）为单位显示内存使用情况。<br />－s delay：显示每隔多少秒数来显示一次内存使用情况。<br />－t：显示内存总和列。<br />－o：不显示缓冲区调节列。<br />4.应用实例<br />free命令是用来查看内存使用情况的主要命令。和top命令相比，它的优点是使用简单，并且只占用很少的系统资源。通过－S参数可以使用free命令不间断地监视有多少内存在使用，这样可以把它当作一个方便实时监控器。<br />＃free －b －s5<br />使用这个命令后终端会连续不断地报告内存使用情况（以字节为单位），每5秒更新一次。<br />(四)    quota<br />1.作用<br />quota命令用来显示磁盘使用情况和限制情况，使用权限超级用户。<br />2.格式<br />quota [－g][－u][－v][－p] 用户名 组名<br />3.参数<br />－g：显示用户所在组的磁盘使用限制。<br />－u：显示用户的磁盘使用限制。<br />－v：显示没有分配空间的文件系统的分配情况。<br />－p：显示简化信息。<br />4.应用实例<br />在企业应用中磁盘配额非常重要，普通用户要学会看懂自己的磁盘使用情况。要查询自己的磁盘配额可以使用下面命令（下例中用户账号是caojh)：<br />＃quota caojh<br />Disk quotas for user caojh(uid 502):<br />Filesystem blocks quota limit grace files quota limit grace<br />/dev/hda3 58 200000 400000 41 500 1000<br />以上显示ID号为502的caojh账号，文件个数设置为500～1000个，硬盘空间限制设置为200MB～400MB。一旦磁盘配额要用完时，就需要删除一些垃圾文件或向系统管理员请求追加配额。<br />(五)    at<br />1.作用<br />at命令用来在指定时刻执行指定的命令序列。<br />2.格式<br />at [－V] [－q x] [－f file] [－m] time<br />3.主要参数<br />－V：显示标准错误输出。<br />－q：许多队列输出。<br />－f：从文件中读取作业。<br />－m：执行完作业后发送电子邮件到用户。<br />time：设定作业执行的时间。time格式有严格的要求，由小时、分钟、日期和时间的偏移量组成，其中日期的格式为MM.DD.YY，MM是分钟，DD是日期，YY是指年份。偏移量的格式为时间＋偏移量，单位是minutes、hours和days。<br />4.应用实例<br />＃at －f data 15:30 +2 days<br />上面命令表示让系统在两天后的17：30执行文件data中指明的作业。<br />(六)    lp<br />1.作用<br />lp是打印文件的命令，使用权限是所有用户。<br />2.格式<br />lp [－c][－d][－m][－number][－title][-p]<br />3.主要参数<br />－c：先拷贝文件再打印。<br />－d：打印队列文件。<br />－m：打印结束后发送电子邮件到用户。<br />－number：打印份数。<br />－title：打印标题。<br />－p：设定打印的优先级别，最高为100。<br />4.应用实例<br />（1）使用lp命令打印多个文件<br />＃lp 2 3 4<br />request id is 11 (3 file(s))<br />其中2、3、4分别是文件名；“request id is 11 (3 file(s)) ”表示这是第11个打印命令，依次打印这三个文件。<br />（2）设定打印优先级别<br />＃lp lp -d LaserJet -p 90 /etc/aliases<br />通过添加“-p 90”，规定了打印作业的优先级为90。它将在优先级低于90的打印作业之前打印，包括没有设置优先级的作业，缺省优先级是50<br />(七)    useradd<br />1.作用<br />useradd命令用来建立用户帐号和创建用户的起始目录，使用权限是超级用户。<br />2.格式<br />useradd [－d home] [－s shell] [－c comment] [－m [－k template]] [－f inactive] [－e expire ] [－p passwd] [－r] name<br />3.主要参数<br />－c：加上备注文字，备注文字保存在passwd的备注栏中。　<br />－d：指定用户登入时的启始目录。<br />－D：变更预设值。<br />－e：指定账号的有效期限，缺省表示永久有效。<br />－f：指定在密码过期后多少天即关闭该账号。<br />－g：指定用户所属的群组。<br />－G：指定用户所属的附加群组。<br />－m：自动建立用户的登入目录。<br />－M：不要自动建立用户的登入目录。<br />－n：取消建立以用户名称为名的群组。<br />－r：建立系统账号。<br />－s：指定用户登入后所使用的shell。<br />－u：指定用户ID号。<br />4.说明<br />useradd可用来建立用户账号，它和adduser命令是相同的。账号建好之后，再用passwd设定账号的密码。使用useradd命令所建立的账号，实际上是保存在/etc/passwd文本文件中。<br />5.应用实例<br />建立一个新用户账户，并设置ID：<br />＃useradd caojh －u 544<br />需要说明的是，设定ID值时尽量要大于500，以免冲突。因为Linux安装后会建立一些特殊用户，一般0到499之间的值留给bin、mail这样的系统账号。<br />(八)    groupadd<br />1.作用<br />groupadd命令用于将新组加入系统。<br />2.格式<br />groupadd [－g gid] [－o]] [－r] [－f] groupname<br />3.主要参数<br />－g gid：指定组ID号。<br />－o：允许组ID号，不必惟一。<br />－r：加入组ID号，低于499系统账号。<br />－f：加入已经有的组时，发展程序退出。<br />4.应用实例<br />建立一个新组，并设置组ID加入系统：<br />＃groupadd －g 344 cjh<br />此时在/etc/passwd文件中产生一个组ID（GID）是344的项目。<br />(九)    kill<br />1.作用<br />kill命令用来中止一个进程。<br />2.格式<br />kill [ －s signal | －p ] [ －a ] pid ...<br />kill －l [ signal ]<br />3.参数<br />－s：指定发送的信号。<br />－p：模拟发送信号。<br />－l：指定信号的名称列表。<br />pid：要中止进程的ID号。<br />Signal：表示信号。<br />4.说明<br />进程是Linux系统中一个非常重要的概念。Linux是一个多任务的操作系统，系统上经常同时运行着多个进程。我们不关心这些进程究竟是如何分配的，或者是内核如何管理分配时间片的，所关心的是如何去控制这些进程，让它们能够很好地为用户服务。<br />Linux 操作系统包括三种不同类型的进程，每种进程都有自己的特点和属性。交互进程是由一个Shell启动的进程。交互进程既可以在前台运行，也可以在后台运行。 批处理进程和终端没有联系，是一个进程序列。监控进程（也称系统守护进程）时Linux系统启动时启动的进程，并在后台运行。例如，httpd是著名的 Apache服务器的监控进程。<br />kill命令的工作原理是，向Linux系统的内核发送一个系统操作信号和某个程序的进程标识号，然后系统内核就可以对进程标识号指定的进程进行操 作。比如在top命令中，我们看到系统运行许多进程，有时就需要使用kill中止某些进程来提高系统资源。在讲解安装和登陆命令时，曾提到系统多个虚拟控 制台的作用是当一个程序出错造成系统死锁时，可以切换到其它虚拟控制台工作关闭这个程序。此时使用的命令就是kill，因为kill是大多数Shell内 部命令可以直接调用的。<br />5.应用实例<br />（1）强行中止（经常使用杀掉）一个进程标识号为324的进程：<br />＃kill －9 324<br />（2）解除Linux系统的死锁<br />在Linux 中有时会发生这样一种情况：一个程序崩溃，并且处于死锁的状态。此时一般不用重新启动计算机，只需要中止(或者说是关闭)这个有问题的程序即可。当 kill处于X-Window界面时，主要的程序(除了崩溃的程序之外)一般都已经正常启动了。此时打开一个终端，在那里中止有问题的程序。比如，如果 Mozilla浏览器程序出现了锁死的情况，可以使用kill命令来中止所有包含有Mozolla浏览器的程序。首先用top命令查处该程序的PID，然 后使用kill命令停止这个程序：<br />＃kill －SIGKILL XXX<br />其中，XXX是包含有Mozolla浏览器的程序的进程标识号。<br />（3）使用命令回收内存<br />我们知道内存对于系统是非常重要的，回收内存可以提高系统资源。kill命令可以及时地中止一些“越轨”的程序或很长时间没有相应的程序。例如，使用top命令发现一个无用 (Zombie) 的进程，此时可以使用下面命令：<br />＃kill －9 XXX<br />其中，XXX是无用的进程标识号。<br />然后使用下面命令：<br />＃free<br />此时会发现可用内存容量增加了。<br />（4）killall命令<br />Linux下还提供了一个killall命令，可以直接使用进程的名字而不是进程标识号，例如：<br />＃ killall -HUP inetd<br />(十)    crontab<br />1.作用<br />使用crontab命令可以修改crontab配置文件，然后该配置由cron公用程序在适当的时间执行，该命令使用权限是所有用户。<br />2.格式<br />crontab [ －u user ] 文件<br />crontab [ －u user ] { －l | －r | －e }<br />3.主要参数<br />－e：执行文字编辑器来设定时程表，内定的文字编辑器是vi。<br />－r：删除目前的时程表。<br />－l：列出目前的时程表。<br />crontab 文件的格式为“M H D m d cmd”。其中，M代表分钟（0～59），H代表小时（0～23），D代表天（1～31），m代表月（1～12），d代表一星期内的天（0～6，0为星期 天）。cmd表示要运行的程序，它被送入sh执行，这个Shell只有USER、HOME、SHELL三个环境变量。<br />4.说明<br />和at命令相比，crontab命令适合完成固定周期的任务。<br />5.应用实例<br />设置一个定时、定期的系统提示：<br />[cao @www cao]#crontab －e<br />此时系统会打开一个vi编辑器。<br />如果输入以下内容：35 17 * * 5 wall "Tomorrow is Saturday I will go CS"，然后存盘退出。这时在/var/spool/cron/目录下会生产一个cao的文件，内容如下：<br /># DO NOT EDIT THIS FILE － edit the master and reinstall.<br /># (/tmp/crontab.2707 installed on Thu Jan 1 22:01:51 2004)<br /># (Cron version －－ $Id: crontab.c,v 2.13 1994/01/17 03:20:37 vixie Exp $)<br />35 17 * * 5 wall "Tomorrow is Saturday I will play CS "<br />这样每个星期五17：35系统就会弹出一个终端，提醒星期六可以打打CS了！显示结果见图3所示。<br />图3 一个定时、定期的系统提示<br />(十一)    动手练习<br />1.联合使用kill和top命令观察系统性能的变化<br />首先启动一个终端运行top命令，然后再启动一个终端使用kill命令，见图4所示。<br />图4 观察kill命令对top终端的影响<br />这时利用上面介绍的kill命令来中止一些程序：<br />＃kill SIGKILL XXX<br />然后再看top命令终端的变化，包括内存容量、CPU使用率、系统负载等。注意，有些进程是不能中止的，不过学习Linux命令时可以试试，看看系统有什么反应。<br />2.使用at和halt命令定时关机<br />首先设定关机时间是17:35，输入下面代码：<br />＃at 17:35<br />warning: commands will be executed using (in order) a) $SHELL b) login shell c) /bin/sh<br />at&gt;halt `-i －p<br />at&gt; &lt;EOT&gt;<br />job 6 at 2004－01－01 17:35<br />此时实际上就已经进入Linux系统的Shell，并且编写一个最简单程序：halt －i －p。上面Shell中的文本结束符号表示按“Ctrl＋D”组合键关闭命令，提交任务退出Shell。“Job 6 at 2004－01－01 17:35”表示系统接受第6个at命令，在“2004－01－01 17:35”时执行命令：先把所有网络相关的装置停止，关闭系统后关闭电源。<br />3.用crontab命令实现每天定时的病毒扫描<br />前面已经介绍了一个简单的crontab命令操作，这里看一些更重要的操作。<br />（1）建立一个文件，文件名称自己设定，假设为caoproject：<br />＃crontab －e<br />（2）文件内容如下：<br />05 09 * * * antivir<br />用vi编辑后存盘退出。antivir是一个查杀Linux病毒的软件，当然需要时先安装在系统中。<br />（3）使用crontab命令添加到任务列表中：<br />＃crontab caoproject<br />这样系统内所有用户在每天的9点05分会自动进行病毒扫描。<br />4.用kill使修改的配置文件马上生效<br />Windows用户一般都知道，重要配置文件修改后往往都要重新启动计算机才能使修改生效。而Linux由于采用了模块化设计，可以自己根据需要实时设定服务。这里以网络服务inetd为例介绍一些操作技巧。<br />inetd 是一个监听守护进程，监听与提供互联网服务进程（如rlogin、telnet、ftp、rsh）进行连接的要求，并扩展所需的服务进程。默认情况 下，inetd监听的这些daemon均列于/etc /inetd.conf文件中。编辑/etc/inetd.conf文件，可以改变inetd启动服务器守护进程的选项，然后驱使inetd以 SIGHUP（signal 1）向当前的inetd进程发送信号，使inetd重读该文件。这一过程由kill命令来实现。<br />用vi或其它编辑器修改inetd.conf后，首先使用下面命令：<br />＃ps -ef |grep inetd<br />上面代码表明查询inetd.conf的进程号(PID)，这里假设是1426，然后使用下面命令：<br />＃ kill -1426 inetd<br />这样配置文件就生效了。<br />这一讲介绍的系统管理命令都是比较重要的，特别是crontab命令和quota命令使用起来会有一定难度，需要多做一些练习。另外，使用kill命令要注意“－9“这个参数，练习时最好不要运行一些重要的程序。</p>
<p> <br />四、网络操作<br />因为Linux系统是在Internet上起源和发展的，它与生俱来拥有强大的网络功能和丰富的网络应用软件，尤其是TCP/IP网络协 议的实现尤为成 熟。Linux的网络命令比较多，其中一些命令像ping、 ftp、telnet、route、netstat等在其它操作系统上也能看到，但也有一些Unix/Linux系统独有的命令，如ifconfig、 finger、mail等。Linux网络操作命令的一个特点是，命令参数选项和功能很多，一个命令往往还可以实现其它命令的功能。<br />(一)    ifconfig<br />1.作用<br />ifconfig用于查看和更改网络接口的地址和参数，包括IP地址、网络掩码、广播地址，使用权限是超级用户。<br />2.格式<br />ifconfig -interface [options] address<br />3.主要参数<br />-interface：指定的网络接口名，如eth0和eth1。<br />up：激活指定的网络接口卡。<br />down：关闭指定的网络接口。<br />broadcast address：设置接口的广播地址。<br />pointopoint：启用点对点方式。<br />address：设置指定接口设备的IP地址。<br />netmask address：设置接口的子网掩码。<br />4.应用说明<br />ifconfig是用来设置和配置网卡的命令行工具。为了手工配置网络，这是一个必须掌握的命令。使用该命令的好处是无须重新启动机器。要赋给eth0接口IP地址207.164.186.2，并且马上激活它，使用下面命令：<br />#fconfig eth0 210.34.6.89 netmask 255.255.255.128 broadcast 210.34.6.127<br />该命令的作用是设置网卡eth0的IP地址、网络掩码和网络的本地广播地址。若运行不带任何参数的ifconfig命令，这个命令将显示机器所有激 活接口的信息。带有“-a”参数的命令则显示所有接口的信息，包括没有激活的接口。注意，用ifconfig命令配置的网络设备参数，机器重新启动以后将 会丢失。<br />如果要暂停某个网络接口的工作，可以使用down参数：<br />#ifconfig eth0 down<br />(二)    ip<br />1.作用<br />ip是iproute2软件包里面的一个强大的网络配置工具，它能够替代一些传统的网络管理工具，例如ifconfig、route等，使用权限为超级用户。几乎所有的Linux发行版本都支持该命令。<br />2.格式<br />ip [OPTIONS] OBJECT [COMMAND [ARGUMENTS]]<br />3.主要参数<br />OPTIONS是修改ip行为或改变其输出的选项。所有的选项都是以-字符开头，分为长、短两种形式。目前，ip支持如表1所示选项。<br />OBJECT是要管理者获取信息的对象。目前ip认识的对象见表2所示。<br />表1 ip支持的选项<br />-V,-Version 打印ip的版本并退出。<br />-s,-stats,-statistics 输出更为详尽的信息。如果这个选项出现两次或多次，则输出的信息将更为详尽。<br />-f,-family 这个选项后面接协议种类，包括inet、inet6或link，强调使用的协议种类。如果没有足够的信息告诉ip使用的协议种类，ip就会使用默认值inet或any。link比较特殊，它表示不涉及任何网络协议。<br />-4 是-family inet的简写。<br />-6 是-family inet6的简写。<br />-0 是-family link的简写。<br />-o,-oneline 对每行记录都使用单行输出，回行用字符代替。如果需要使用wc、grep等工具处理ip的输出，则会用到这个选项。<br />-r,-resolve 查询域名解析系统，用获得的主机名代替主机IP地址<br />COMMAND 设置针对指定对象执行的操作，它和对象的类型有关。一般情况下，ip支持对象的增加(add)、删除(delete)和展示(show或list)。有些 对象不支持这些操作，或者有其它的一些命令。对于所有的对象，用户可以使用help命令获得帮助。这个命令会列出这个对象支持的命令和参数的语法。如果没 有指定对象的操作命令，ip会使用默认的命令。一般情况下，默认命令是list，如果对象不能列出，就会执行help命令。<br />ARGUMENTS 是命令的一些参数，它们倚赖于对象和命令。ip支持两种类型的参数：flag和parameter。flag由一个关键词组成；parameter由一个 关键词加一个数值组成。为了方便，每个命令都有一个可以忽略的默认参数。例如，参数dev是ip link命令的默认参数，因此ip link ls eth0等于ip link ls dev eth0。我们将在后面的详细介绍每个命令的使用，命令的默认参数将使用default标出。<br />4.应用实例<br />添加IP地址192.168.2.2/24到eth0网卡上：<br />#ip addr add 192.168.1.1/24 dev eth0<br />丢弃源地址属于192.168.2.0/24网络的所有数据报：<br />#ip rule add from 192.168.2.0/24 prio 32777 reject<br />(三)    ping<br />1.作用<br />ping检测主机网络接口状态，使用权限是所有用户。<br />2.格式<br />ping [-dfnqrRv][-c][-i][-I][-l][-p][-s][-t] IP地址<br />3.主要参数<br />-d：使用Socket的SO_DEBUG功能。<br />-c：设置完成要求回应的次数。<br />-f：极限检测。<br />-i：指定收发信息的间隔秒数。<br />-I：网络界面使用指定的网络界面送出数据包。<br />-l：前置载入，设置在送出要求信息之前，先行发出的数据包。<br />-n：只输出数值。<br />-p：设置填满数据包的范本样式。<br />-q：不显示指令执行过程，开头和结尾的相关信息除外。<br />-r：忽略普通的Routing Table，直接将数据包送到远端主机上。<br />-R：记录路由过程。<br />-s：设置数据包的大小。<br />-t：设置存活数值TTL的大小。<br />-v：详细显示指令的执行过程。<br />ping 命令是使用最多的网络指令，通常我们使用它检测网络是否连通，它使用ICMP协议。但是有时会有这样的情况，我们可以浏览器查看一个网页，但是却无法 ping通，这是因为一些网站处于安全考虑安装了防火墙。另外，也可以在自己计算机上试一试，通过下面的方法使系统对ping没有反应：<br /># echo 1 &gt; /proc/sys/net/ipv4/icmp_echo_ignore_all<br />(四)    netstat<br />1.作用<br />检查整个Linux网络状态。<br />2.格式<br />netstat [-acCeFghilMnNoprstuvVwx][-A][--ip]<br />3.主要参数<br />-a--all：显示所有连线中的Socket。<br />-A：列出该网络类型连线中的IP相关地址和网络类型。<br />-c--continuous：持续列出网络状态。<br />-C--cache：显示路由器配置的快取信息。<br />-e--extend：显示网络其它相关信息。<br />-F--fib：显示FIB。<br />-g--groups：显示多重广播功能群组组员名单。<br />-h--help：在线帮助。<br />-i--interfaces：显示网络界面信息表单。<br />-l--listening：显示监控中的服务器的Socket。<br />-M--masquerade：显示伪装的网络连线。<br />-n--numeric：直接使用IP地址，而不通过域名服务器。<br />-N--netlink--symbolic：显示网络硬件外围设备的符号连接名称。<br />-o--timers：显示计时器。<br />-p--programs：显示正在使用Socket的程序识别码和程序名称。<br />-r--route：显示Routing Table。<br />-s--statistice：显示网络工作信息统计表。<br />-t--tcp：显示TCP传输协议的连线状况。<br />-u--udp：显示UDP传输协议的连线状况。<br />-v--verbose：显示指令执行过程。<br />-V--version：显示版本信息。<br />-w--raw：显示RAW传输协议的连线状况。<br />-x--unix：和指定“-A unix”参数相同。<br />--ip--inet：和指定“-A inet”参数相同。<br />4.应用实例<br />netstat 主要用于Linux察看自身的网络状况，如开启的端口、在为哪些用户服务，以及服务的状态等。此外，它还显示系统路由表、网络接口状态等。可以说，它是一 个综合性的网络状态的察看工具。在默认情况下，netstat只显示已建立连接的端口。如果要显示处于监听状态的所有端口，使用-a参数即可：<br />#netstat -a<br />Active Internet connections (only servers)<br />Proto Recv-Q Send-Q Local Address Foreign Address State<br />tcp 0 0 *:32768 *:* LISTEN<br />tcp 0 0 *:32769 *:* LISTEN<br />tcp 0 0 *:nfs *:* LISTEN<br />tcp 0 0 *:32770 *:* LISTEN<br />tcp 0 0 *:868 *:* LISTEN<br />tcp 0 0 *:617 *:* LISTEN<br />tcp 0 0 *:mysql *:* LISTEN<br />tcp 0 0 *:netbios-ssn *:* LISTEN<br />tcp 0 0 *:sunrpc *:* LISTEN<br />tcp 0 0 *:10000 *:* LISTEN<br />tcp 0 0 *:http *:* LISTEN<br />......<br />上面显示出，这台主机同时提供HTTP、FTP、NFS、MySQL等服务。<br />(五)    telnet<br />1.作用<br />telnet表示开启终端机阶段作业，并登入远端主机。telnet是一个Linux命令，同时也是一个协议（远程登陆协议）。<br />2.格式<br />telnet [-8acdEfFKLrx][-b][-e][-k][-l][-n][-S][-X][主机名称IP地址&lt;通信端口&gt;]<br />3.主要参数<br />-8：允许使用8位字符资料，包括输入与输出。<br />-a：尝试自动登入远端系统。<br />-b：使用别名指定远端主机名称。<br />-c：不读取用户专属目录里的.telnetrc文件。<br />-d：启动排错模式。<br />-e：设置脱离字符。<br />-E：滤除脱离字符。<br />-f：此参数的效果和指定“-F”参数相同。<br />-F：使用Kerberos V5认证时，加上此参数可把本地主机的认证数据上传到远端主机。<br />-k：使用Kerberos认证时，加上此参数让远端主机采用指定的领域名，而非该主机的域名。<br />-K：不自动登入远端主机。<br />-l：指定要登入远端主机的用户名称。<br />-L：允许输出8位字符资料。<br />-n：指定文件记录相关信息。<br />-r：使用类似rlogin指令的用户界面。<br />-S：服务类型，设置telnet连线所需的IP TOS信息。<br />-x：假设主机有支持数据加密的功能，就使用它。<br />-X：关闭指定的认证形态。<br />4.应用说明<br />用户使用telnet命令可以进行远程登录，并在远程计算机之间进行通信。用户通过网络在远程计算机上登录，就像登录到本地机 上执行命令一样。为了通过 telnet登录到远程计算机上，必须知道远程机上的合法用户名和口令。虽然有些系统确实为远程用户提供登录功能，但出于对安全的考虑，要限制来宾的操作 权限，因此，这种情况下能使用的功能是很少的。<br />telnet只为普通终端提供终端仿真，而不支持X-Window等图形环境。当允许远程用户登录时，系统通常把这些用户放在一个受限制的 Shell中，以防系统被怀有恶意的或不小心的用户破坏。用户还可以使用telnet从远程站点登录到自己的计算机上，检查电子邮件、编辑文件和运行程 序，就像在本地登录一样。<br />(六)    ftp<br />1.作用<br />ftp命令进行远程文件传输。FTP是ARPANet的标准文件传输协议，该网络就是现今Internet的前身，所以ftp既是协议又是一个命令。<br />2.格式<br />ftp [-dignv][主机名称IP地址]<br />3.主要参数<br />-d：详细显示指令执行过程，便于排错分析程序执行的情形。<br />-i：关闭互动模式，不询问任何问题。<br />-g：关闭本地主机文件名称支持特殊字符的扩充特性。<br />-n：不使用自动登陆。<br />-v：显示指令执行过程。<br />4.应用说明<br />ftp 命令是标准的文件传输协议的用户接口，是在TCP/IP网络计算机之间传输文件简单有效的方法，它允许用户传输ASCⅡ文件和二进制文件。为了使用ftp 来传输文件，用户必须知道远程计算机上的合法用户名和口令。这个用户名/口令的组合用来确认ftp会话，并用来确定用户对要传输的文件进行什么样的访问。 另外，用户需要知道对其进行ftp会话的计算机名字的IP地址。<br />用户可以通过使用ftp客户程序，连接到另一台计算机上；可以在目录中上下移动、列出目录内容；可以把文件从远程计算机机拷贝到本地机上；还可以把文件从本地机传输到远程系统中。ftp内部命令有72个，下面列出主要几个内部命令：<br />ls：列出远程机的当前目录。<br />cd：在远程机上改变工作目录。<br />lcd：在本地机上改变工作目录。<br />close：终止当前的ftp会话。<br />hash：每次传输完数据缓冲区中的数据后就显示一个#号。<br />get（mget）：从远程机传送指定文件到本地机。<br />put（mput）：从本地机传送指定文件到远程机。<br />quit：断开与远程机的连接，并退出ftp。<br />(七)    route<br />1.作用<br />route表示手工产生、修改和查看路由表。<br />2.格式<br />#route [-add][-net|-host] targetaddress [-netmask Nm][dev]If]<br />#route [－delete][-net|-host] targetaddress [gw Gw] [-netmask Nm] [dev]If]<br />3.主要参数<br />-add：增加路由。<br />-delete：删除路由。<br />-net：路由到达的是一个网络，而不是一台主机。<br />-host：路由到达的是一台主机。<br />-netmask Nm：指定路由的子网掩码。<br />gw：指定路由的网关。<br />[dev]If：强迫路由链指定接口。<br />4.应用实例<br />route命令是用来查看和设置Linux系统的路由信息，以实现与其它网络的通信。要实现两个不同的子网之间的通信，需要一台连接两个网络的路由器，或者同时位于两个网络的网关来实现。<br />在Linux系统中，设置路由通常是为了解决以下问题：该Linux系统在一个局域网中，局域网中有一个网关，能够让机器访问Internet，那么就需要将这台机器的IP地址设置为Linux机器的默认路由。使用下面命令可以增加一个默认路由：<br />route add 0.0.0.0 192.168.1.1<br />(八)    rlogin<br />1.作用<br />rlogin用来进行远程注册。<br />2.格式<br />rlogin [ -8EKLdx ] [ -e char ] [-k realm ] [ - l username ] host<br />3.主要参数<br />-8：此选项始终允许8位输入数据通道。该选项允许发送格式化的ANSI字符和其它的特殊代码。如果不用这个选项，除非远端的不是终止和启动字符，否则就去掉奇偶校验位。<br />-E：停止把任何字符当作转义字符。当和-8选项一起使用时，它提供一个完全的透明连接。<br />-K：关闭所有的Kerberos确认。只有与使用Kerberos 确认协议的主机连接时才使用这个选项。<br />-L：允许rlogin会话在litout模式中运行。要了解更多信息，请查阅tty联机帮助。<br />-d：打开与远程主机进行通信的TCP sockets的socket调试。要了解更多信息，请查阅setsockopt的联机帮助。<br />-e：为rlogin会话设置转义字符，默认的转义字符是“～”。<br />-k：请求rlogin获得在指定区域内远程主机的Kerberos许可，而不是获得由krb_realmofhost(3)确定的远程主机区域内的远程主机的Kerberos许可。<br />-x：为所有通过rlogin会话传送的数据打开DES加密。这会影响响应时间和CPU利用率，但是可以提高安全性。<br />4.使用说明<br />如果在网络中的不同系统上都有账号，或者可以访问别人在另一个系统上的账号，那么要访问别的系统中的账号，首先就要注册到系统中，接着通过网络远程注册到账号所在的系统中。rlogin可以远程注册到别的系统中，它的参数应是一个系统名。<br />(九)    rcp<br />1.作用<br />rcp代表远程文件拷贝，用于计算机之间文件拷贝，使用权限是所有用户。<br />2.格式<br />rcp [-px] [-k realm] file1 file2 rcp [-px] [-r] [-k realm] file<br />3.主要参数<br />-r：递归地把源目录中的所有内容拷贝到目的目录中。要使用这个选项，目的必须是一个目录。<br />-p：试图保留源文件的修改时间和模式，忽略umask。<br />-k：请求rcp获得在指定区域内的远程主机的Kerberos许可，而不是获得由krb_relmofhost(3)确定的远程主机区域内的远程主机的Kerberos许可。<br />-x：为传送的所有数据打开DES加密。<br />(十)    finger<br />1.作用<br />finger用来查询一台主机上的登录账号的信息，通常会显示用户名、主目录、停滞时间、登录时间、登录Shell等信息，使用权限为所有用户。<br />2.格式<br />finger [选项] [使用者] [用户@主机]<br />3.主要参数<br />-s：显示用户注册名、实际姓名、终端名称、写状态、停滞时间、登录时间等信息。<br />-l：除了用-s选项显示的信息外，还显示用户主目录、登录Shell、邮件状态等信息，以及用户主目录下的.plan、.project和.forward文件的内容。<br />-p：除了不显示.plan文件和.project文件以外，与-l选项相同。<br />4.应用实例<br />在计算机上使用finger：<br />[root@localhost root]# Finger<br />Login Name Tty Idle Login Time Office Office Phone<br />root root tty1 2 Dec 15 11<br />root root pts/0 1 Dec 15 11<br />root root *pts/1 Dec 15 11<br />5.应用说明<br />如果要查询远程机上的用户信息，需要在用户名后面接“@主机名”，采用[用户名@主机名]的格式，不过要查询的网络主机需要运行finger守护进程的支持。<br />(十一)    mail<br />1.作用<br />mail作用是发送电子邮件，使用权限是所有用户。此外，mail还是一个电子邮件程序。<br />2.格式<br />mail [-s subject] [-c address] [-b address]<br />mail -f [mailbox]mail [-u user]<br />3.主要参数<br />-b address：表示输出信息的匿名收信人地址清单。<br />-c address：表示输出信息的抄送（）收信人地址清单。<br />-f [mailbox]：从收件箱者指定邮箱读取邮件。<br />-s subject：指定输出信息的主体行。<br />[-u user]：端口指定优化的收件箱读取邮件。<br />(十二)    nslookup<br />1.作用<br />nslookup命令的功能是查询一台机器的IP地址和其对应的域名。使用权限所有用户。它通常需要一台域名服务器来提供域名服务。如果用户已经设置好域名服务器，就可以用这个命令查看不同主机的IP地址对应的域名。<br />2.格式<br />nslookup ［IP地址/域名］<br />3.应用实例<br />（1）在本地计算机上使用nslookup命令<br />$ nslookup<br />Default Server: name.cao.com.cn<br />Address: 192.168.1.9<br />&gt;<br />在符号“&gt;”后面输入要查询的IP地址域名，并回车即可。如果要退出该命令，输入“exit”，并回车即可。<br />（2）使用nslookup命令测试named<br />输入下面命令：<br />nslookup<br />然后就进入交换式nslookup环境。如果named正常启动，则nslookup会显示当前DNS服务器的地址和域名，否则表示named没能正常启动。<br />下面简单介绍一些基本的DNS诊断。<br />◆ 检查正向DNS解析，在nslookup提示符下输入带域名的主机名，如hp712.my.com，nslookup应能显示该主机名对应的IP地址。如 果只输入hp712，nslookup会根据/etc/resolv.conf的定义，自动添加my.com域名，并回答对应的IP地址。<br />◆检查反向DNS解析，在nslookup提示符下输入某个IP地址，如192.22.33.20，nslookup应能回答该IP地址所对应的主机名。<br />◆检查MX邮件地址记录在nslookup提示符下输入：<br />set q=mx<br />然后输入某个域名，输入my.com和mail.my.com，nslookup应能够回答对应的邮件服务器地址，即support.my.com和support2.my.com。<br />(十三)    动手练习<br />1.危险的网络命令<br />互联网的发展使安全成为一个不能忽视的问题，finger、ftp、rcp和telnet在本质上都是不安全的，因为它 们在网络上用明文传送口令和数据，嗅探器可以非常容易地截获这些口令和数据。而且，这些服务程序的安全验证方式也是有弱点的，很容易受到“中间服务器”方 式的攻击。这里笔者把一些不安全的命令根据危险等级列出，见表3所示。<br />现在ftp、telnet可以被SSH命令代替绑定在端口22上，其连接采用协商方式，使用RSA加密。身份鉴别完成之后，后面的所有流量都使用 IDEA 进行加密。SSH（Secure　Shell）程序可以通过网络登录到远程主机，并执行命令。rcp、rlogin等远程调用命令也逐渐被VNC软件代 替。<br />2.在一张网卡上绑定多个IP地址<br />在Linux下，可以使用ifconfig方便地绑定多个IP地址到一张网卡。例如，eth0接口的原有IP地址为192.168.0 .254，可以执行下面命令：<br />ifconfig eth0:0 192.168.0.253 netmask 255.255.255.0<br />ifconfig eth0:1 192.168.0.252 netmask 255.255.255.0<br />......<br />3.修改网卡MAC地址<br />首先必须关闭网卡设备，命令如下：<br />/sbin/ifconfig eth0 down<br />修改MAC地址，命令如下：<br />/sbin/ifconfig eth0 hw ether 00:AA:BB:CC:DD:EE<br />重新启用网卡：<br />/sbin/ifconfig eht0 up<br />这样网卡的MAC地址就更改完成了。每张网卡的MAC地址是惟一，但不是不能修改的，只要保证在网络中的MAC地址的惟一性就可以了。<br />4.初步部署IPv6<br />IPv4 技术在网络发展中起到了巨大的作用，不过随着时间的流逝它无论在网络地址的提供、服务质量、安全性等方面都越来越力不从心，IPv6呼之欲出。Linux 是所有操作系统中最先支持IPv6的，一般Linux基于2.4内核的Linux发行版本都可以直接使用IPv6，不过主要发行版本没有加载IPv6模 块，可以使用命令手工加载，需要超级用户的权限。<br />(1)加载IPv6模块<br />使用命令检测，其中inet6 addr: fe80::5054:abff:fe34:5b09/64，就是eth0网卡的IPv6地址。<br /># modprobe IPv6<br />＃ifconfig<br />eth0 Link encap:Ethernet HWaddr 52:54:AB:34:5B:09<br />inet addr:192.168.1.2 Bcast:192.168.1.255 Mask:255.255.255.0<br />inet6 addr: fe80::5054:abff:fe34:5b09/64 Scope:Link<br />UP BROADCAST RUNNING MULTICAST MTU:1500 Metric:1<br />RX packets:0 errors:0 dropped:0 overruns:0 frame:0<br />TX packets:21 errors:0 dropped:0 overruns:0 carrier:0<br />collisions:0 txqueuelen:100<br />RX bytes:0 (0.0 b) TX bytes:1360 (1.3 Kb)<br />Interrupt:5 Base address:0xec00<br />(2)使用ping命令检测网卡的IPv6地址是否有效<br />#ping6 -I eth0 -c 2 fe80::200:e8ff:fea0:2586<br />和IPv4不一样，使用ping6命令时必须指定一个网卡界面，否则系统不知道将数据包发送到哪个网络设备。I表示Interface、eth0是第一个网卡，－c表示回路，2表示ping6操作两次。结果见图1所示。<br />图1 IPv6网络下的ping6命令<br />(3)使用ip命令在IPv6下为eth0增加一个IP地址<br />#ip -6 addr add 3ffe:ffff:0:f101::1/64 dev eth0<br />使用ifconfig命令，查看网卡是否出现第二个IPv6地址。<br />Linux网络的主要优点是能够实现资源和信息的共享，并且用户可以远程访问信息。Linux提供了一组强有力的网络命令来为用户服务，这些工具能够帮助用户进行网络设定、检查网络状况、登录到远程计算机上、传输文件和执行远程命令等。<br />上面介绍了Linux中比较重要的网络命令，其实Linux还有许多命令需要学习。Linux网络操作命令的一个特点就是命令参数选项很多，并不要求全部记住，关键在于理解命令的主要用途和学会使用帮助信息。</p>
<p> <br />五、系统安全<br />虽然Linux和Windows NT/2000系统一样是一个多用户的系统，但是它们之间有不少重要的差别。对于很多习惯了Windows系统的管理员来讲，如何保证Linux操作系统安全、可靠将会面临许多新的挑战。本文将重点介绍Linux系统安全的命令。<br />(一)    passwd<br />1.作用<br />passwd命令原来修改账户的登陆密码，使用权限是所有用户。<br />2.格式<br />passwd [选项] 账户名称<br />3.主要参数<br />-l：锁定已经命名的账户名称，只有具备超级用户权限的使用者方可使用。<br />-u：解开账户锁定状态，只有具备超级用户权限的使用者方可使用。<br />-x, --maximum=DAYS：最大密码使用时间（天），只有具备超级用户权限的使用者方可使用。<br />-n, --minimum=DAYS：最小密码使用时间（天），只有具备超级用户权限的使用者方可使用。<br />-d：删除使用者的密码, 只有具备超级用户权限的使用者方可使用。<br />-S：检查指定使用者的密码认证种类, 只有具备超级用户权限的使用者方可使用。<br />4.应用实例<br />$ passwd<br />Changing password for user cao.<br />Changing password for cao<br />(current) UNIX password:<br />New UNIX password:<br />Retype new UNIX password:<br />passwd: all authentication tokens updated successfully.<br />从上面可以看到，使用passwd命令需要输入旧的密码，然后再输入两次新密码。<br />(二)    su<br />1.作用<br />su的作用是变更为其它使用者的身份，超级用户除外，需要键入该使用者的密码。<br />2.格式<br />su [选项]... [-] [USER [ARG]...]<br />3.主要参数<br />-f ， --fast：不必读启动文件（如 csh.cshrc 等），仅用于csh或tcsh两种Shell。<br />-l ， --login：加了这个参数之后，就好像是重新登陆为该使用者一样，大部分环境变量（例如HOME、SHELL和USER等）都是以该使用者（USER）为主，并且工作目录也会改变。如果没有指定USER，缺省情况是root。<br />-m， -p ，--preserve-environment：执行su时不改变环境变数。<br />-c command：变更账号为USER的使用者，并执行指令（command）后再变回原来使用者。<br />USER：欲变更的使用者账号，ARG传入新的Shell参数。<br />4.应用实例<br />变更账号为超级用户，并在执行df命令后还原使用者。 su -c df root<br />(三)    umask<br />1.作用<br />umask设置用户文件和目录的文件创建缺省屏蔽值，若将此命令放入profile文件，就可控制该用户后续所建文件的存取许可。它告诉系统在创建文件时不给谁存取许可。使用权限是所有用户。<br />2.格式<br />umask [-p] [-S] [mode]<br />3.参数<br />－S：确定当前的umask设置。<br />－p：修改umask 设置。<br />[mode]：修改数值。<br />4.说明<br />传统Unix的umask值是022，这样就可以防止同属于该组的其它用户及别的组的用户修改该用户的文件。既然每个用户都拥有并 属于一个自己的私有组，那么这种“组保护模式”就不在需要了。严密的权限设定构成了Linux安全的基础，在权限上犯错误是致命的。需要注意的 是，umask命令用来设置进程所创建的文件的读写权限，最保险的值是0077，即关闭创建文件的进程以外的所有进程的读写权限，表示为 -rw-------。在～/.bash_profile中，加上一行命令umask 0077可以保证每次启动Shell后, 进程的umask权限都可以被正确设定。<br />5.应用实例<br />umask -S<br />u=rwx,g=rx,o=rx<br />umask -p 177<br />umask -S<br />u=rw,g=,o=<br />上述5行命令，首先显示当前状态，然后把umask值改为177，结果只有文件所有者具有读写文件的权限，其它用户不能访问该文件。这显然是一种非常安全的设置。<br />(四)    chgrp<br />1.作用<br />chgrp表示修改一个或多个文件或目录所属的组。使用权限是超级用户。<br />2.格式<br />chgrp [选项]... 组 文件...<br />或<br />chgrp [选项]... --reference=参考文件 文件...<br />将每个&lt;文件&gt;的所属组设定为&lt;组&gt;。<br />3.参数<br />-c, --changes ：像 --verbose，但只在有更改时才显示结果。<br />--dereference：会影响符号链接所指示的对象，而非符号链接本身。<br />-h, --no-dereference：会影响符号链接本身，而非符号链接所指示的目的地(当系统支持更改符号链接的所有者，此选项才有效)。<br />-f, --silent, --quiet：去除大部分的错误信息。<br />--reference=参考文件：使用&lt;参考文件&gt;的所属组，而非指定的&lt;组&gt;。<br />-R, --recursive：递归处理所有的文件及子目录。<br />-v, --verbose：处理任何文件都会显示信息。<br />4.应用说明<br />该命令改变指定指定文件所属的用户组。其中group可以是用户组ID，也可以是/etc/group文件中用户组的组名。文件名是以空格分开的要改变属组的文件列表，支持通配符。如果用户不是该文件的属主或超级用户，则不能改变该文件的组。<br />5.应用实例<br />改变/opt/local /book/及其子目录下的所有文件的属组为book，命令如下：<br />$ chgrp - R book /opt/local /book<br />(五)    chmod<br />1.作用<br />chmod命令是非常重要的，用于改变文件或目录的访问权限，用户可以用它控制文件或目录的访问权限，使用权限是超级用户。<br />2.格式<br />chmod命令有两种用法。一种是包含字母和操作符表达式的字符设定法（相对权限设定）；另一种是包含数字的数字设定法（绝对权限设定）。<br />（1）字符设定法<br />chmod [who] [+ | - | =] [mode] 文件名<br />◆操作对象who可以是下述字母中的任一个或它们的组合<br />u：表示用户，即文件或目录的所有者。<br />g：表示同组用户，即与文件属主有相同组ID的所有用户。<br />o：表示其它用户。<br />a：表示所有用户，它是系统默认值。<br />◆操作符号<br />+：添加某个权限。<br />-：取消某个权限。<br />=：赋予给定权限，并取消其它所有权限（如果有的话）。<br />◆设置mode的权限可用下述字母的任意组合<br />r：可读。<br />w：可写。<br />x：可执行。<br />X：只有目标文件对某些用户是可执行的或该目标文件是目录时才追加x属性。<br />s：文件执行时把进程的属主或组ID置为该文件的文件属主。方式“u＋s”设置文件的用户ID位，“g＋s”设置组ID位。<br />t：保存程序的文本到交换设备上。<br />u：与文件属主拥有一样的权限。<br />g：与和文件属主同组的用户拥有一样的权限。<br />o：与其它用户拥有一样的权限。<br />文件名：以空格分开的要改变权限的文件列表，支持通配符。<br />一个命令行中可以给出多个权限方式，其间用逗号隔开。<br />（2） 数字设定法<br />数字设定法的一般形式为： chmod [mode] 文件名<br />数字属性的格式应为3个0到7的八进制数，其顺序是(u)(g)(o)文件名，以空格分开的要改变权限的文件列表，支持通配符。<br />数字表示的权限的含义如下：0001为所有者的执行权限；0002为所有者的写权限；0004为所有者的读权限；0010为组的执行权限；0020 为组的写权限；0040为组的读权限；0100为其他人的执行权限；0200为其他人的写权限；0400为其他人的读权限；1000为粘贴位置 位；2000表示假如这个文件是可执行文件，则为组ID为位置位，否则其中文件锁定位置位；4000表示假如这个文件是可执行文件，则为用户ID为位置 位。<br />3.实例<br />如果一个系统管理员写了一个表格(tem)让所有用户填写，那么必须授权用户对这个文件有读写权限，可以使用命令：＃chmod 666 tem<br />上面代码中，这个666数字是如何计算出来的呢？0002为所有者的写权限，0004为所有者的读权限，0020为组的写权限，0040为组的读权 限， 0200为其他人的写权限，0400为其他人的读权限，这6个数字相加就是666（注以上数字都是八进制数），结果见图1所示。<br />图1 用chmod数字方法设定文件权限<br />从图1可以看出，tem文件的权限是-rw-rw-rw-，即用户对这个文件有读写权限。<br />如果用字符权限设定使用下面命令：<br />＃chmod a =wx tem<br />(六)    chown<br />1.作用<br />更改一个或多个文件或目录的属主和属组。使用权限是超级用户。<br />2.格式<br />chown [选项] 用户或组 文件<br />3.主要参数<br />--dereference：受影响的是符号链接所指示的对象，而非符号链接本身。<br />-h, --no-dereference：会影响符号链接本身，而非符号链接所指示的目的地(当系统支持更改符号链接的所有者，此选项才有效)。<br />--from=目前所有者:目前组只当每个文件的所有者和组符合选项所指定的，才会更改所有者和组。其中一个可以省略，这已省略的属性就不需要符合原有的属性。<br />-f, --silent, --quiet：去除大部分的错误信息。<br />-R, --recursive：递归处理所有的文件及子目录。<br />-v, --verbose：处理任何文件都会显示信息。<br />4.说明<br />chown 将指定文件的拥有者改为指定的用户或组，用户可以是用户名或用户ID；组可以是组名或组ID；文件是以空格分开的要改变权限的文件列表，支持通配符。系统管理员经常使用chown命令，在将文件拷贝到另一个用户的目录下以后，让用户拥有使用该文件的权限。<br />5.应用实例<br />1.把文件shiyan.c的所有者改为wan<br />$ chown wan shiyan.c<br />2.把目录/hi及其下的所有文件和子目录的属主改成wan，属组改成users。<br />$ chown - R wan.users /hi<br />(七)    chattr<br />1.作用<br />修改ext2和ext3文件系统属性(attribute)，使用权限超级用户。<br />2.格式<br />chattr [-RV] [-+=AacDdijsSu] [-v version] 文件或目录<br />3.主要参数<br />－R：递归处理所有的文件及子目录。<br />－V：详细显示修改内容，并打印输出。<br />－：失效属性。<br />＋：激活属性。<br />= ：指定属性。<br />A：Atime，告诉系统不要修改对这个文件的最后访问时间。<br />S：Sync，一旦应用程序对这个文件执行了写操作，使系统立刻把修改的结果写到磁盘。<br />a：Append Only，系统只允许在这个文件之后追加数据，不允许任何进程覆盖或截断这个文件。如果目录具有这个属性，系统将只允许在这个目录下建立和修改文件，而不允许删除任何文件。<br />i：Immutable，系统不允许对这个文件进行任何的修改。如果目录具有这个属性，那么任何的进程只能修改目录之下的文件，不允许建立和删除文件。<br />D：检查压缩文件中的错误。<br />d：No dump，在进行文件系统备份时，dump程序将忽略这个文件。<br />C：Compress，系统以透明的方式压缩这个文件。从这个文件读取时，返回的是解压之后的数据；而向这个文件中写入数据时，数据首先被压缩之后才写入磁盘。<br />s：Secure Delete，让系统在删除这个文件时，使用0填充文件所在的区域。<br />u：Undelete，当一个应用程序请求删除这个文件，系统会保留其数据块以便以后能够恢复删除这个文件。<br />4.说明<br />chattr 命令的作用很大，其中一些功能是由Linux内核版本来支持的，如果Linux内核版本低于2.2，那么许多功能不能实现。同样－D检查压缩文件中的错误 的功能，需要2.5.19以上内核才能支持。另外，通过chattr命令修改属性能够提高系统的安全性，但是它并不适合所有的目录。chattr命令不能 保护/、/dev、/tmp、/var目录。<br />5.应用实例<br />1.恢复/root目录,即子目录的所有文件<br /># chattr -R +u/root<br />2.用chattr命令防止系统中某个关键文件被修改<br />在Linux下，有些配置文件(passwd ,fatab)是不允许任何人修改的，为了防止被误删除或修改，可以设定该文件的“不可修改位(immutable)”，命令如下：<br /># chattr +i /etc/fstab<br />(八)    sudo<br />1.作用<br />sudo是一种以限制配置文件中的命令为基础，在有限时间内给用户使用，并且记录到日志中的命令，权限是所有用户。<br />2.格式<br />sudo [-bhHpV] [-s &lt;shell&gt;] [-u &lt;用户&gt;] [指令]<br />sudo [-klv]<br />3.主要参数<br />－b：在后台执行命令。<br />-h：显示帮助。<br />-H：将HOME环境变量设为新身份的HOME环境变量。<br />-k：结束密码的有效期，即下次将需要输入密码。<br />-l：列出当前用户可以使用的命令。<br />-p：改变询问密码的提示符号。<br />-s &lt;shell&gt;：执行指定的Shell。<br />-u &lt;用户&gt;：以指定的用户为新身份，不使用时默认为root。<br />-v：延长密码有效期5分钟。<br />4.说明<br />sudo 命令的配置在/etc/sudoers文件中。当用户使用sudo时，需要输入口令以验证使用者身份。随后的一段时间内可以使用定义好的命令，当使用配置文件中没有的命令时，将会有报警的记录。sudo是系统管理员用来允许某些用户以root身份运行部分/全部系统命令的程序。一个明显的用途是增强了站点的安全性，如果需要每天以超级用户的身份做一些日常工作，经常执行一些固定的几个只有超级用户身份才能执行的命令，那么用sudo是非常适合的。<br />(九)    ps<br />1.作用<br />ps显示瞬间进程 (process) 的动态，使用权限是所有使用者。<br />2.格式<br />ps [options] [--help]<br />3.主要参数<br />ps的参数非常多, 此出仅列出几个常用的参数。<br />-A：列出所有的进程。<br />-l：显示长列表。<br />-m：显示内存信息。<br />-w：显示加宽可以显示较多的信息。<br />-e：显示所有进程。<br />a：显示终端上的所有进程,包括其它用户的进程。<br />-au：显示较详细的信息。<br />-aux：显示所有包含其它使用者的进程。<br />4.说明<br />要对进程进行监测和控制，首先要了解当前进程的情况，也就是需要查看当前进程。ps命令就是最基本、也是非常强大的进程查看命令。 使用该命令可以确定有哪些进程正在运行、运行的状态、进程是否结束、进程有没有僵尸、哪些进程占用了过多的资源等。图2给出了ps-aux命令详解。大部 分信息都可以通过执行该命令得到。最常用的三个参数是u、a、x。下面就结合这三个参数详细说明ps命令的作用：ps aux<br />图2 ps-aux命令详解<br />图2第2行代码中，USER表示进程拥有者；PID表示进程标示符；%CPU表示占用的CPU使用率；%MEM占用的物理内存使用率；VSZ表示占用的虚拟内存大小；RSS为进程占用的物理内存值；TTY为终端的次要装置号码。<br />STAT 表示进程的状态，其中D为不可中断的静止（I/O动作）；R正在执行中；S静止状态；T暂停执行；Z不存在，但暂时无法消除；W没有足够的内存分页可分 配；高优先序的进程；N低优先序的进程；L有内存分页分配并锁在内存体内 (实时系统或 I/O)。START为进程开始时间。TIME为执行的时间。COMMAND是所执行的指令。<br />4.应用实例<br />在进行系统维护时，经常会出现内存使用量惊人，而又不知道是哪一个进程占用了大量进程的情况。除了可以使用top命令查看内存使用情况之外，还可以使用下面的命令：<br />ps aux | sort +5n<br />(十)    who<br />1.作用<br />who显示系统中有哪些用户登陆系统，显示的资料包含了使用者ID、使用的登陆终端、上线时间、呆滞时间、CPU占用，以及做了些什么。 使用权限为所有用户。<br />2.格式<br />who - [husfV] [user]<br />3.主要参数<br />-h：不要显示标题列。<br />-u：不要显示使用者的动作/工作。<br />-s：使用简短的格式来显示。<br />-f：不要显示使用者的上线位置。<br />-V：显示程序版本。<br />4.说明<br />该命令主要用于查看当前在线上的用户情况。如果用户想和其它用户建立即时通信，比如使用talk命令，那么首先要确定的就是该用户 确实在线上,不然 talk进程就无法建立起来。又如，系统管理员希望监视每个登录的用户此时此刻的所作所为，也要使用who命令。who命令应用起来非常简单，可以比较准 确地掌握用户的情况,所以使用非常广泛。<br />(十一)    动手练习<br />1.使用Linux命令检测系统入侵者<br />安装过Mandrake Linux和Red Hat Linux的用户都会知道，Linux系统会内置三种不同级别（标准、高、更高）的防火墙，当进行了Linux服务器的安装和一些基本的设置后，服务器应 该说是比较安全的，但是也会有黑客通过各种方法利用系统管理员的疏忽侵入系统。如何快速查找黑客非常重要。一般来说，可以使用命令查询黑客是否入侵，见表 1。<br />表1 查询黑客入侵现象的命令对应表<br />举例说明，如果黑客嗅探网络，那么它必须使网卡接口处于混杂模式，使用下面命令进行查询：<br />＃ifconfig -a<br />eth0 Link encap:Ethernet HWaddr 00:00:E8:A0:25:86<br />inet addr:192.168.1.7 Bcast:192.168.1.255 Mask:255.255.255.0<br />UP BROADCAST RUNNING PROMISCUOUS MTU:1500 Metric:1<br />......<br />从这个命令的输出中，可以看到上面讲到的这些概念。第一行的00:00:E8:A0:25:86是mac地址，第二行的192.168.1.7是 IP地址，第四行讲的是接收数据状态，这时正在被黑客嗅探。一般而言，网卡有几种接收数据帧的状态，如Broadcast、Multicast、 Promiscuous等。Broadcast是指接收所有类型为广播报文的数据帧；Multicast是指接收特定的组播报文；Promiscuous 则是通常说的混杂模式，是指对报文中的目的硬件地址不加任何检查、全部接收的工作模式。<br />2.限制su命令的滥用<br />我们知道，超级用户在Linux中有最大的权利，几乎所有黑客都想得到这个目标。Linux可以增加对切换到超级用 户的限制。使用PAM （Pluggable Authentication Modules）可以禁止除在wheel组以外的任何人su成root，修改/etc/pam.d/su文件，除去屏蔽标识#。使用 /usr/sbin/usermod G10 bjecadm将bjecadm这个账号加入gid为10的组，就是wheel组。命令如下：<br />/etc/pam.d/su # 使用密码验证＃<br />auth sufficient /lib/security/pam_wheel.so debug<br /># 限制只有wheel组用户才可以切换到root＃<br />auth required /lib/security/pam_wheel.so use_uid<br />chmod -G10 bjecadm<br />另外，每当用户试图使用su命令进入系统用户时,命令将在/usr/adm/sulog文件中写一条信息,若该文件记录了大量试图用su进入root的无效操作信息,则表明了可能有人企图破译root口令。<br />Linux命令有着强大的功能。对于Linux系统管理员来说，往往只需要通过各种安全命令技巧，组合构成安全防线。从计算机安全的角度看，世界上没有绝对安全的计算机系统，Linux系统也不例外。</p>
<p> <br />六、其他<br />在前面几讲中，我们把Linux命令按照在系统中的作用分成几个部分分别予以介绍。但是，还有一些命令不好划分，然而学习它们同样是比较重要的。<br />(一)    tar<br />1.作用<br />tar命令是Unix/Linux系统中备份文件的可靠方法，几乎可以工作于任何环境中，它的使用权限是所有用户。<br />2.格式<br />tar [主选项+辅选项] 文件或目录<br />3.主要参数<br />使用该命令时，主选项是必须要有的，它告诉tar要做什么事情，辅选项是辅助使用的，可以选用。<br />主选项：<br />-c 创建新的档案文件。如果用户想备份一个目录或是一些文件，就要选择这个选项。<br />-r 把要存档的文件追加到档案文件的未尾。例如用户已经做好备份文件，又发现还有一个目录或是一些文件忘记备份了，这时可以使用该选项，将忘记的目录或文件追加到备份文件中。<br />-t 列出档案文件的内容，查看已经备份了哪些文件。<br />-u 更新文件。就是说，用新增的文件取代原备份文件，如果在备份文件中找不到要更新的文件，则把它追加到备份文件的最后。<br />-x 从档案文件中释放文件。<br />辅助选项：<br />-b 该选项是为磁带机设定的，其后跟一数字，用来说明区块的大小，系统预设值为20（20×512 bytes）。<br />-f 使用档案文件或设备，这个选项通常是必选的。<br />-k 保存已经存在的文件。例如把某个文件还原，在还原的过程中遇到相同的文件，不会进行覆盖。<br />-m 在还原文件时，把所有文件的修改时间设定为现在。<br />-M 创建多卷的档案文件，以便在几个磁盘中存放。<br />-v 详细报告tar处理的文件信息。如无此选项，tar不报告文件信息。<br />-w 每一步都要求确认。<br />-z 用gzip来压缩/解压缩文件，加上该选项后可以将档案文件进行压缩，但还原时也一定要使用该选项进行解压缩。<br />4.应用说明<br />tar 是Tape Archive（磁带归档）的缩写，最初设计用于将文件打包到磁带上。如果下载过Linux的源代码，或许已经碰到过tar文件<br />请注意，不要忘了Linux是区分大小写的。例如，tar命令应该总是以小写的形式执行。命令行开关可以是大写、小写或大小写的混合。例如，-t和-T执行不同的功能。文件或目录名称可以混合使用大小写，而且就像命令和命令行开关一样是区分大小写的。<br />5.应用实例<br />tar是一个命令行的工具，没有图形界面。使用Konsole打开一个终端窗口，接下来是一个简单的备份命令（在/temp目录中创建一个back.tar的文件，/usr目录中所有内容都包含在其中。）：<br />$tar cvf - /usr &gt; /temp/back.tar<br />另外，tar命令支持前面第三讲中讲过的crontab命令，可以用crontab工具设置成基于时间的有规律地运行。例如，每晚6点把/usr目 录备份到hda—第一个IDE接口的主驱动器 (总是位于第一个硬盘)中，只要将下面语句添加到root的crontab中即可：<br />$00 06 * * * tar cvf /dev/hda1/usrfiles.tar - /usr<br />一般情况下，以下这些目录是需要备份的：<br />◆/etc 包含所有核心配置文件，其中包括网络配置、系统名称、防火墙规则、用户、组，以及其它全局系统项。<br />◆ /var 包含系统守护进程（服务）所使用的信息，包括DNS配置、DHCP租期、邮件缓冲文件、HTTP服务器文件、dB2实例配置等。<br />◆/home 包含所有默认用户的主目录，包括个人设置、已下载的文件和用户不希望失去的其它信息。<br />◆/root 根（root）用户的主目录。<br />◆/opt 是安装许多非系统文件的地方。IBM软件就安装在这里。OpenOffice、JDK和其它软件在默认情况下也安装在这里。<br />有些目录是可以不备份的：<br />◆ /proc 应该永远不要备份这个目录。它不是一个真实的文件系统，而是运行内核和环境的虚拟化视图，包括诸如/proc/kcore这样的文件，这个文件是整个运行内存的虚拟视图。备份这些文件只是在浪费资源。<br />◆/dev 包含硬件设备的文件表示。如果计划还原到一个空白的系统，就可以备份/dev。然而，如果计划还原到一个已安装的Linux 系统，那么备份/dev是没有必要的。<br />(二)    unzip<br />1.作用<br />unzip 命令位于/usr/bin目录中，它们和MS DOS下的pkzip、pkunzip及MS Windows中的Winzip软件功能一样，将文件压缩成.zip文件，以节省硬盘空间，当需要的时候再将压缩文件用unzip命令解开。该命令使用权 限是所有用户。<br />2.格式<br />unzip [-cflptuvz][-agCjLMnoqsVX][-P &lt;密码&gt;][.zip文件][文件][-d &lt;目录&gt;][-x &lt;文件&gt;]<br />3.主要参数<br />-c：将解压缩的结果显示到屏幕上，并对字符做适当的转换。<br />-f：更新现有的文件。<br />-l：显示压缩文件内所包含的文件。<br />-p：与-c参数类似，会将解压缩的结果显示到屏幕上，但不会执行任何的转换。<br />-t：检查压缩文件是否正确。<br />-u：与-f参数类似，但是除了更新现有的文件外，也会将压缩文件中的其它文件解压缩到目录中。<br />-v：执行是时显示详细的信息。<br />-z：仅显示压缩文件的备注文字。<br />-a：对文本文件进行必要的字符转换。<br />-b：不要对文本文件进行字符转换。<br />-C：压缩文件中的文件名称区分大小写。<br />-j：不处理压缩文件中原有的目录路径。<br />-L：将压缩文件中的全部文件名改为小写。<br />-M：将输出结果送到more程序处理。<br />-n：解压缩时不要覆盖原有的文件。<br />-o：不必先询问用户，unzip执行后覆盖原有文件。<br />-P&lt;密码&gt;：使用zip的密码选项。<br />-q：执行时不显示任何信息。<br />-s：将文件名中的空白字符转换为底线字符。<br />-V：保留VMS的文件版本信息。<br />-X：解压缩时同时回存文件原来的UID/GID。<br />[.zip文件]：指定.zip压缩文件。<br />[文件]：指定要处理.zip压缩文件中的哪些文件。<br />-d&lt;目录&gt;：指定文件解压缩后所要存储的目录。<br />-x&lt;文件&gt;：指定不要处理.zip压缩文件中的哪些文件。<br />-Z unzip：-Z等于执行zipinfo指令。在Linux中，还提供了一个叫zipinfo的工具，能够察看zip压缩文件的详细信息。unzip最新版本是5.50。<br />(三)    gunzip<br />1.作用<br />gunzip命令作用是解压文件，使用权限是所有用户。<br />2.格式<br />gunzip [-acfhlLnNqrtvV][-s &lt;压缩字尾字符串&gt;][文件...]<br />或者<br />gunzip [-acfhlLnNqrtvV][-s &lt;压缩字尾字符串&gt;][目录]<br />3.主要参数<br />-a或--ascii：使用ASCII文字模式。<br />-c或--stdout或--to-stdout：把解压后的文件输出到标准输出设备。<br />-f或-force：强行解开压缩文件，不理会文件名称或硬连接是否存在，以及该文件是否为符号连接。<br />-h或--help：在线帮助。<br />-l或--list：列出压缩文件的相关信息。<br />-L或--license：显示版本与版权信息。<br />-n或--no-name：解压缩时，若压缩文件内含有原来的文件名称及时间戳记，则将其忽略不予处理。<br />-N或--name：解压缩时，若压缩文件内含有原来的文件名称及时间戳记，则将其回存到解开的文件上。<br />-q或--quiet：不显示警告信息。<br />-r或--recursive：递归处理，将指定目录下的所有文件及子目录一并处理。<br />-S&lt;压缩字尾字符串&gt;或--suffix&lt;压缩字尾字符串&gt;：更改压缩字尾字符串。<br />-t或--test：测试压缩文件是否正确无误。<br />-v或--verbose：显示指令执行过程。<br />-V或--version：显示版本信息。<br />4.说明<br />gunzip是个使用广泛的解压缩程序，它用于解开被gzip压缩过的文件，这些压缩文件预设最后的扩展名为“.gz”。事实上，gunzip就是gzip的硬连接，因此不论是压缩或解压缩，都可通过gzip指令单独完成。gunzip最新版本是1.3.3 。<br />(四)    unarj<br />1.作用<br />unarj解压缩格式为.arj格式的文件，使用权限是所有用户。<br />2.格式<br />unarj [eltx][.arj压缩文件]<br />3.主要参数<br />e：解压缩.arj文件。<br />l：显示压缩文件内所包含的文件。<br />t：检查压缩文件是否正确。<br />x：解压缩时保留原有的路径。<br />4.说明<br />带有.arj扩展名的文件是由用于MS DOS和Windows的ARJ实用程序创建的。因为ARJ是一种不能免费获得源代码的共享件程序，所以在<br />(五)    mtools<br />1.作用<br />mtools 实际上是一个命令集合，是DOS文件系统的工具程序，它可以模拟许多DOS命令，使用起来非常方便。使用权限是所有用户。Linux系统提供了一组称为 mtools的可移植工具，可以让用户轻松地从标准的DOS软盘上读、写文件和目录。它们对DOS和Linux环境之间交换文件非常有用。mtools的 使用非常简单，如果想把软盘里所有的文件都拷贝到硬盘上，那么就可以执行以下命令：<br />mcopy a:*.*<br />也就是说，只需要在相应的DOS命令之前加上一个字母“m”，就可以完成对应的功能了。一般Linux发行版本中都有这个软件，可以使用下面命令检查一下。<br />rpm -qa|grep mtools<br />如果没有安装，也没有关系，可以从网上下载(<a href="http://mtools.linux.lu/" rel="external nofollow noreferrer">http://mtools.linux.lu/</a>)一个最新版本来安装。目前可供下载的最新mtools版本是<br />2.包括的命令<br />mcd 目录名：改变MS DOS下的目录。<br />mcopy 源文件 目标文件：在MS DOS和Unix之间复制文件。<br />mdel 文件名：删除MS DOS下的文件。<br />mdir 目录名：显示MS DOS下的目录。<br />mformat 驱动器号：在低级格式化的软盘上创建MS DOS文件系统。<br />rnlabel 驱动器号：产生MS DOS下的卷标。<br />mmd 目录名：建立MS DOS下的目录。<br />mrd 目录名：删除MS DOS下的目录。<br />mren 源文件 目标文件：重新命名已存在的MS DOS文件。<br />mtype 文件名：显示MS DOS文件的内容。<br />请注意，这些命令和对应的MS DOS命令非常相似。在mtools命令中，“/”和“\”是可以混用的。因为文件列表的是DOS系统下的文档，对大小写并不敏感，所以“CDE”和“cde”在这里是一样的。<br />3.应用实例<br />(1)如果把软盘进行快速格式化，可以使用命令mformat：<br />mformat A：<br />mtools 当初发展的目的是用来处理DOS文件系统的，所以只能用在FAT文件格式的分区上。需要注意的是，如果用mount命令来挂载了FAT16/32分区，那 么就不能使用mtools的指令来处理这些分区上的文件。这是因为一旦FAT16/32分区挂到了Linux文件目录下，Linux就会将其视为文件系统 本身的一部分，这时如果要对其操作就必须使用Linux本身所附带的指令集。<br />(2)将DOS盘上的文件htca.c复制到当前目录下，并用ls命令进行验证。<br />$ mcopy a:\htca.c<br />$ ls -l htca.c<br />-rw-r- -r- - 1 xxq xxq 27136 Jan 1 01:80 htca.c<br />(六)    man<br />1.作用<br />man命令用来提供在线帮助，使用权限是所有用户。在Linux系统中存储着一部联机使用的手册，以供用户在终端上查找。使用man命令可以调阅其中的帮助信息，非常方便和实用。<br />2.格式<br />man 命令名称<br />man [-acdfhkKtwW] [-m system] [-p string] [-C config_file] [-M path] [-P pager] [-S section_list] [section] name ...<br />3.参数<br />-C config_file：指定设定文件man.conf，缺省值是/etc/man.conf。<br />-M path：指定了联机手册的搜寻路径, 如果没有指定则使用环境变数MANPATH的设定；如果没有使用MANPATH， 则会使用/usr/lib/man.conf内的设定；如果MANPATH是空字串，则表示使用缺省值。<br />-P pager：指定使用何种pager.man会优先使用此选项设定，然后是依环境变数MANPAGER设定，然后是环境变数PAGER；man缺省使用/usr/bin/less -is。<br />-S section_list man：所搜寻的章节列表(以冒号分隔)，此选项会覆盖环境变数MANSECT的设定。<br />-a man：缺省情况是在显示第一个找到的手册之后，就会停止搜寻，使用此选项会强迫man继续显示所有符合name的联机手册。<br />-c：即使有最新的cat page，也继续对联机手册重新作排版，本选项在屏幕的行列数改变时或已排版的联机手册损坏时特别有意义。<br />-d：不要真的显示联机手册，只显示除错讯息。<br />-D：同时显示联机手册与除错讯息。<br />-h：显示求助讯息然后结束程式 。<br />-K：对所有的联机手册搜寻所指定的字串。请注意，本功能回应速度可能很慢，如果指定section（区域）会对速度有帮助。<br />-m system：依所指定的system名称而指定另一组的联机手册。<br />man：是manual（手册）的缩写。在输入命令有困难时，可以立刻得到这个文档。例如, 如果使用ps命令时遇到困难，可以输入man ps得到帮助信息，此时会显示出ps的手册页（man page）。<br />由于手册页man page是用less程序来看的(可以方便地使屏幕上翻和下翻), 所以在man page里可以使用less的所有选项。<br />less中比较重要的功能键有:<br />[q] 退出；<br />[Enter] 一行行地下翻；<br />[Space] 一页页地下翻；<br />[b] 上翻一页；<br />[/] 后跟一个字符串和[Enter]来查找字符串；<br />[n] 发现上一次查找的下一个匹配。<br />4.阅读手册页<br />手册页在很少的空间里提供了很多的信息，这里简单介绍一下大多数手册页中都有的部分内容。Linux 手册页主要有九个部分： 用户指令、系统调用、程序库、设备说明、文件格式、游戏、杂项、系统指令、内核，手册页快照见图1所示。<br />图1 ps命令手册页快照<br />Linux手册页布局见表1。<br />5.应用实例<br />Linux 命令中有一些基础的、重要的命令，例如ps、find、cat和ls等。下面来举一个综合应用的例子，由此可以看出man的地位在Linux中可谓至关重 要。但是，man所显示的信息却不是普通的文本，如果直接将这些文字重定向到一个文本文件，就会发现在man中高亮显示的文字就变成了两个，而且有不计其数的制表符，使打印、编辑都变得非常不便。不过，使用下面这样一条语句就能得到ps命令打印。<br /># man ps | col -b | lpr<br />这条命令同时运用了输出重定向和管道两种技巧，作用是将ps命令的帮助信息可以直接打印出来。更多的Man文件可以查看Linux Man<br />(七)    unencode<br />1.作用<br />unencode命令可以把一个二进制文件表编码为一个文本文件，使用权限是所有用户。<br />2.格式<br />uuencode [-hv] [源文件] 目标文件<br />3.主要参数<br />－h：列出指令使用格式(help) 。<br />－v：列出版本信息。<br />4.应用说明<br />uuencode指令可以将二进制文件转化成可使用电子邮件发送的ASCII编码形式。uuencode编码后的资料都以 begin开始，以end作为结束，且通常其中的每一行的开始均为“M”，中间部分是编码过的文件，编码后的文件比源文件要大一些。<br />(八)    uudecode<br />1.作用<br />uudecode命令用来将uuencode编码后的档案还原，uudecode只会将begin与end标记之间的编码资料还原，程序会跳过标记以外的资料。它的使用权限为所有用户。<br />2.格式<br />uuencode [-hv] [file1 ...]<br />3.主要参数<br />－h：列出指令使用格式(help)。<br />－v：列出版本信息。<br />4.应用实例<br />使用下面命令一次还原几个文件：<br />uuencode file1.uud file2.uud file3.uud<br />(九)    动手练习<br />1.在Linux命令行下发送邮件<br />虽然Linux桌面应用发展很快，但是命令行（Shell）在Linux中依然有很强的生命力。如果能确认电子邮件服务器支持8bit的字节，就可以直接使用下面命令：<br />cat ＜附件文件名＞ | mail ＜邮件地址＞<br />cat（cat是concatenate的缩写）命令是将几个文件处理成一个文件，并将这种处理的结果保存到一个单独的输出文件，这里我们用它来合并邮件的文本。<br />写好邮件名称，比如叫cjkmail，然后使用下面命令：<br />$uuencode ＜附件文件名＞ ＜附件文件名＞ &gt;&gt;cjkmail<br />这样就可以用vi编辑器写cjkmail文件，并在前面写上信的正文，然后寄出。<br />对方收到信后，把信中属于cjkmail中的内容拷贝出来，存为themail.uue。如果对方是在Windows下，就可以用WinRAR或WinZip解压，这样就可以看到附件。<br />如果对方也使用Linux，可以用undecode命令还原：<br />$ uudencode -o＜附件文件名＞ themail.uue<br />2.实现tar的分卷<br />笔者想把一个378MB的文件压缩成多个63MB的文件（笔者的USB为64MB），使用下面命令：<br />$tar czvf - dir | split -d -b 63m<br />然后合并命令：<br />$cat x* &gt; dir.tgz<br />以上例子实际是由三个命令组合完成的，即用tar打包，用split分割，用cat合并。“tar czvf - dir”的意思是把dir目录打包，并输出到标准输出（argv），这样就可以直接用管道输出给split。<br />3.连续执行一个命令<br />使用watch命令，可以反复执行命令。如果和ls配合，可以达到观察某文件大小变化的效果。<br />$watch ls －l file.name<br />4.用tar命令导出一个文件<br />有一个tar格式的DVD文件GLvPro6.4_linux.tar，因为该文件非常大（4.7GB），如果全部解压比较麻烦，可以用下面命令先导出readme.txt看看。<br />tar xvf GLvPro6.4_linux.tar readme.txt<br />这样readme.txt就单独被导出了。<br />5.用tar打包一个目录时只备份其中的几个子目录<br />tar cf --exclude home/cjh home/cao<br />这样home目录下只有cjh和cao两个子目录备份。<br />到此为止，Linux必学的60个命令已经全部介绍完了。Linux的命令行方式功能强大，如果熟练掌握了Linux的常用命令，往往只需要通过各 种技巧就可以组合构成一条复杂的命令，从而完成用户任务。Linux系统中的命令实在是太多了，不可能像在MS DOS中把所有的命令及参数都记住。Linux系统提供了一些方法，比如可以通过“help”和“man”来查询名令。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-18 13:36:40</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/shell/" title="shell">shell</a>, <a href="https://www.iamivan.net/tag/%e4%b8%bb%e6%9c%ba/" title="主机">主机</a>, <a href="https://www.iamivan.net/tag/%e6%ad%a3%e5%88%99%e8%a1%a8%e8%be%be%e5%bc%8f/" title="正则表达式">正则表达式</a>, <a href="https://www.iamivan.net/tag/linux/" title="linux">linux</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>linux常用命令加实例大全的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0RK1nz.html" rel="bookmark">积累linux常用命令大全&lowbar;linux shell</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本人记忆力有限,就把平时在项目中遇到的linux常用命令分享给大家. Linux常用命令全集 http://www.jb51.net/linux/ linux文件中存在^M 使用shell命令tr可以实现去除,具体命令如下: 复制代码 代码如下:   cat -v yourfile | tr -d &quot;^M&quot; &gt; targetfile VIM中选定某个单词 在ESC之后,使用w或者wi或者vwi可以选择某个单词 在控制台中快速移动光标 1.删除 1.1 ctrl + d 删除光标所			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxEQX7p.html" rel="bookmark">Linux新手必备100个命令 Linux常用命令大全</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux常用命令大全100条: 1.echo &quot;aa&quot; &gt; test.txt 和 echo &quot;bb&quot; &gt;&gt; test.txt//&gt;将原文件清空,并且内容写入到文件中,&gt;&gt;将内容放到文件的尾部 2.chmod go+w -R /home/zhangy //给组用户和其他用户添加写的权限 3.tar -tzvf test.tar.gz //列出归档内容 4.du -ah //查看文件列表大小 5.du -sh //查看所有文件的大小			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDkWjvp.html" rel="bookmark">《嵌入式 Linux应用程序开发标准教程（第2版）》&mdash;&mdash;2&period;1 Linux常用命令</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.1 Linux常用命令 嵌入式 Linux应用程序开发标准教程(第2版) 在安装完Linux再次启动之后,就可以进入到与Windows类似的图形化界面了.这个界面就是Linux图形化界面X窗口系统(简称X)的一部分.要注意的是,X窗口系统仅仅是Linux上面的一个软件(或者也可称为服务),它不是Linux自身的一部分.虽然现在的X窗口系统已经与Linux整合得相当好了,但毕竟还不能保证绝对的可靠性.另外,X窗口系统是一个相当耗费系统资源的软件,它会大大地降低Linux的系统性能.因此,若是希			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQN8k0M.html" rel="bookmark">Linux &vert; 常用命令（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				整理了一下linux常用命令,方便大家使用和学习. 一.文件处理命令 1.命令格式与目录处理命令 ls –a[查看隐藏文件] ls –l[查看文件信息长格式显示] ls –d[查看指定目录的详细信息] ls –h[显示容量大小] ls –i[查看任何文件的I 节点] ll 文件名[查看一个文件的详细信息] 2.目录处理命令 mkdir –p[递归创建目录] cd[切换指定目录] pwd[显示当前目录] rmdir[删除空目录] cp[复制文件到某个目录下] cp –r[复制目录] cp –p[保			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7wn9Zz.html" rel="bookmark">不允许错过的Linux常用命令集合&lowbar;Linux</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				直接贴上学习笔记: 系统信息 arch 显示机器的处理器架构(1) uname -m 显示机器的处理器架构(2) uname -r 显示正在使用的内核版本 dmidecode -q 显示硬件系统部件 - (SMBIOS / DMI) hdparm -i /dev/hda 罗列一个磁盘的架构特性 hdparm -tT /dev/sda 在磁盘上执行测试性读取操作 cat /proc/cpuinfo 显示CPU info的信息 cat /proc/interrupts 显示中断 cat /proc/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQPQDWz.html" rel="bookmark">linux常用命令有哪些？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  Linux系统 Linux的常用命令有: echo 命令 举例:echo $PATH. 功能:将命令行中的参数显示到标准输出中. date命令 举例:date. 功能:显示或设置系统时间,没参数直接显示系统当前的日期和时间. Linux命令 passwd命令 举例:passwd. 功能:修改密码. file命令 举例:file 文件名 [参数]. 功能:确定指定文件类型. ls命令 举例 ls -a 显示当前目录下的全部文件(包括隐藏文件). 功能:列出目录文件. touch命令 举例:to			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWXEdAp.html" rel="bookmark">Centos学习笔记 linux 常用命令：压缩解压命令</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  2012-2-9 星期4 linux 常用命令:压缩解压命令 -gz命令的英文原意:Gnu zip 语法:gzip 选项[文件] 功能描述:压缩文件 压缩后文件格式: .gz 1. 只能压缩文件,不能压缩目录 2.不保留源文件 解压缩命令:gunzip 语法:gunzip选项[压缩文件] 功能描述:解压缩.gz的压缩文件 范例:gunzip file1.gz 压缩解压目录:tar 命令名称:tar 语法 tar选项[cvf][目录]      -c 产生.tar打包文件      -v 显示			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Eee4z.html" rel="bookmark">Linux rpm命令参数使用大全&lpar;经典&rpar;&lowbar;linux shell</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				RPM是RedHat Package Manager(RedHat软件包管理工具)类似Windows里面的&quot;添加/删除程序&quot; rpm 执行安装包 二进制包(Binary)以及源代码包(Source)两种.二进制包可以直接安装在计算机中,而源代码包将会由RPM自动编译.安装.源代码包经常以src.rpm作为后缀名. 常用命令组合: -ivh:安装显示安装进度--install--verbose--hash -Uvh:升级软件包--Update: -qpl:列出RPM软件包内的文件信息[Q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnwngkz.html" rel="bookmark">java 工程师 linux常用命令</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				查找文件 find / -name filename.text //跟根据名称查找 / 目录下的filename.txt文件 find .-name &quot;.xml&quot; //递归查找所有.xml文件 find .-name &quot;.xml&quot; |xargs grep &quot;Hello World&quot; //递归查找所有文件内容包含了hello World的xml文件 grep -H 'spring' *.xml //查找所以有的包含spring的xml文件 find			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkxoEz.html" rel="bookmark" class="title">CSS&plus;JavaScript打造超酷右键菜单</a>
					<div>
						css|javascript|菜单|右键 其实在网页上实现右键菜单的风格化已经是一个老话题了,正常情况下,网页上的右键菜单是默认IE右键选项,包括了一些常用的功能. 但有时候我们会遇到这样的问题,我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzw0nRb.html" rel="bookmark" class="title">ASP精华文摘－001  &lpar;转）</a>
					<div>
						精华|文摘 来源:www.yesky.com转贴-RESPONSE对象(2000.03.22) RESPONSE对象 RESPONSE对象非常有用而且功能丰富.这里我们将要给大家介绍的是其最基本的功能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOvkqp.html" rel="bookmark" class="title">asp&period;net验证码生成类&lpar;参考&rpar;</a>
					<div>
						asp.net|参考|验证码 **********************Created by Chen************************** *如果你觉得本人的文章好,要引用请尊重著作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yxv3z.html" rel="bookmark" class="title">支持异步同步的分布式CommandBus MSMQ实现：支持Session传递、多实例处理</a>
					<div>
						先上一张本文所描述的适用场景图 分布式场景,共3台server: 前端Server Order App Server Warehouse App Server 功能: 前端Server可以不停的发送C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7716b.html" rel="bookmark" class="title">快乐Node码农的十个习惯</a>
					<div>
						从问世到现在将近20年,JavaScript一直缺乏其它有吸引力的编程语言,比如Python和Ruby,的很多优点:命令行界面,REPL,包管理器,以及组织良好的开源社区.感谢Node.js和npm, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgK3d6M.html" rel="bookmark" class="title">MySQL中删除大表的性能问题</a>
					<div>
						微博上讨论MySQL在删除大表engine=innodb(30G+)时,如何减少MySQL hang的时间,现做一下简单总结:(微博地址:http://weibo.com/1642466057/yuP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLOBeb.html" rel="bookmark" class="title">C&num;视频监控系列&lpar;14&rpar;：总结贴&mdash;&mdash;VC&plus;&plus;代码转成C&num;小结</a>
					<div>
						前言 原计划是再写一篇H264播放器转换AVI的文章才开始写总结的,至今未能成功,由于时间问题并且也暂时没有这个需求,所以决 定从原计划中去掉这一章节直接进入总结贴,然后结束这个系列文章.如果公司这边 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PdDnM.html" rel="bookmark" class="title">使用CSS3来实现滚动视差效果的教程</a>
					<div>
						  &quot;视差(parallax)&quot;效果现在在互联网上越来越流行了.如果你还没听说过什么是视差效果,它其实就是利用图片形成不同的层,分别以不同的速度,不同的方向移动产生的效果.这会产生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jmDZb.html" rel="bookmark" class="title">ZBrush如何创建精确的CG动物</a>
					<div>
						  我们一起来向3D雕刻艺术家Gordon Goane学习,看他如何通过严格的10步工作流程创建精确的CG动物. 1.概念化 这一步通常涉及寻找灵感和参考,同时可能要画出粗略的想法. 2.建模 Cla ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd71d4M.html" rel="bookmark" class="title">PS制作英文填充效果的术文字</a>
					<div>
						  下面这个文字效果,是用英文字体排列而成,并填充在这个艺术文字当中,这种效果的文字图片看起来非常漂亮,我们先来看看最终的效果图吧:   一.建立一个新文件,然后用一个非常粗的字体写一个9字,当然你也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7KZ8M.html" rel="bookmark" class="title">暗色调人像后期思路</a>
					<div>
						  玩转情绪风格 暗色调人像后期思路,.前期一定要对整个片子有一个大概的规划.还有就是提升审美,多看多学 分类: PS调色教程 ps后期处理教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW19EGz.html" rel="bookmark" class="title">PHP动态规划解决0-1背包问题实例分析</a>
					<div>
						 这篇文章主要介绍了PHP动态规划解决0-1背包问题,实例分析了背包问题的原理与实现技巧,需要的朋友可以参考下     本文实例分析了PHP动态规划解决0-1背包问题.分享给大家供大家参考.具体分析如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKk5Jdb.html" rel="bookmark" class="title">如何解决开word每次都要进入配置窗口</a>
					<div>
						  在备份过程中,客户反映经常出现每次打开word207都会进入office2007配置窗口,导致进入word非常慢.经查询技术资料,这个问题可能是因为多版本offic共e同存在导致的.解决办法如下: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywWAPz.html" rel="bookmark" class="title">PS利用通道给春季泛白的外景图片加上蓝色天空</a>
					<div>
						  用通道来换天空是比较快的.只需要选好合适的通道并复制,在副本通道中把暗部及高光对比加大,需要保留的部分直接涂成黑色,然后把通道变为选区,把选区反选就得到需要保留的部分.复制图片后在底部添加想要的天 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6XZ3b.html" rel="bookmark" class="title">Win7计算机中如何隐藏界面菜单栏？</a>
					<div>
						  对于大多数电脑用户而言都是非专业的从事计算机行业的,对于计算机界面,除非去编辑文件夹,我想我们打开他的机会都不多,其中:查看→映射网络驱动器.断开网络驱动器.打开同步中心,这些我们甚至不知道是什么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwgd3p.html" rel="bookmark" class="title">视频流-live555音视频同时播放问题</a>
					<div>
						问题描述 live555音视频同时播放问题 我用live555搭了一个rtsp服务端,开了两个队列,一个存放已经编码的H264数据,一个存放已编码的AAC数据.视频帧率15,音频采样率8000.开两个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOax3vM.html" rel="bookmark" class="title">【V直播】三专家解读波士顿动力Atlas惊艳后空翻7大技术难点</a>
					<div>
						会后空翻的波士顿动力Atals机器人 三位嘉宾分别是: 段晋军,东南大学博士生,2015年9月-2016年9月在新加坡南洋理工大学访学.研究方向是多机器人协作.基于阻抗模型的灵巧双臂位置力协调控制.增 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGw6Vp.html" rel="bookmark" class="title">CSS十问&mdash;&mdash;好奇心&plus;刨根问底&equals;CSSer （转）</a>
					<div>
						  最近有时间,想把酝酿的几篇博客都写出来,今天前端小学生带着10个问题,跟大家分享一下学习CSS的一些体会,我觉得想学好CSS,必须保持一颗好奇心和刨根问底的劲头,而不是复制粘贴,得过且过.本人能力 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqA7OYM.html" rel="bookmark" class="title">请问怎么在网页文本编辑器中插入服务器控件啊&quest;</a>
					<div>
						问题描述 请问怎么在网页文本编辑器中插入服务器控件啊? 如图一:想插入一个服务器控件Textbox 然后回到界面上,什么都没有 再回去插入的地方,居然多了这样的标签 不解 解决方案 你怎么插入的?客户 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6gY3M.html" rel="bookmark" class="title">刚开始学hibernate第一个小程序就出了问题，希望指点</a>
					<div>
						问题描述 错误信息如下:Exception in thread &quot;main&quot; org.hibernate.InvalidMappingException: Unable to re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NmEyM.html" rel="bookmark" class="title">有趣的 Google 隐藏功能</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 GOOGLE:大概很多人和我一样不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamYlnb.html" rel="bookmark" class="title">php 如何获取ftp上目录下的所有文件，包括子目录文件</a>
					<div>
						问题描述 php 如何获取ftp上目录下的所有文件,包括子目录文件 php 如何获取ftp上目录下的所有文件,包括子目录文件: 就是给一个目录名,可以得到此目录下所有的文件,包括子目录下的文件 解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRkX5b.html" rel="bookmark" class="title">php导出csv文件&comma;可导出前导0实例代码&lowbar;php实例</a>
					<div>
						实例一:可导出前导0 //导出csv格式文件 $data数据 $title_arr标题 $file_name文件名 function exportCsv($data,$title_arr,$file_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKK86p.html" rel="bookmark" class="title">mysql 数据丢失</a>
					<div>
						问题描述 系统环境:Linuxversion2.6.18-194.el5PAEmysql5.0.22,forpc-linux-gnumysql-connector-java-5.1.1-alpha-b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8jlAb.html" rel="bookmark" class="title">junit-关于Junit测试代码的编写</a>
					<div>
						问题描述 关于Junit测试代码的编写 实在是搞不定了,苦逼程序女就各位大神帮助import java.util.Scanner; public class MoneyCalculate { publ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44xOrz.html" rel="bookmark" class="title">四大广告集团致信美司法部：支持微软雅虎交易</a>
					<div>
						10月19日消息,据国外媒体报道,全球四大广告集团CEO联名致信美国司法部,表示支持微软雅虎的搜索交易,希望该交易尽快获得审批.目前该交易在美国和欧洲都处于审批阶段. 美国广告公司联盟CEO南希·希尔 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkJWAM.html" rel="bookmark" class="title">人民币再升值：留学机构获益？</a>
					<div>
						最近人民币持续升值,昨对美元汇率报价6.1811,再创新高.对日元.澳元.英镑汇率也持续走高.人民币升值往往带动出国消费潮,留学成本也相应降低,这对留学服务机构们算不算一个利好呢?今年以来,人民币兑美 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqRDXp.html" rel="bookmark" class="title">&lpar;NO&period;00005&rpar;iOS实现炸弹人游戏&lpar;七&rpar;&colon;游戏数据的序列化表示</a>
					<div>
						大熊猫猪·侯佩原创或翻译作品.欢迎转载,转载请注明出处. 如果觉得写的不好请告诉我,如果觉得不错请多多支持点赞.谢谢! hopy ;) 用plist列表文件来表示游戏数据 因为在这个炸弹人游戏中有很多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWjGQp.html" rel="bookmark" class="title">Core Data多线程环境下pendingChange引发的排序不对问题</a>
					<div>
						这是一个起初看起来很神奇的问题,大意如下: 有一个Table,展示多个消息会话,这些消息会话按最新消息时间排序: 某种情况下,新收到一条消息,时间展示为最新,但这条消息没有排在最上方. 因为界面上展示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7ZOdp.html" rel="bookmark" class="title">博达通控智能楼宇工程解决方案</a>
					<div>
						智能楼宇工程是一个庞大的系统工程,其特点是系统多且 复杂,综合性强,专业领域广,设备品种多,施工周 期长,作业空间大,协调工作难度大,并且随着http://www.aliyun.com/zixun/a ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.038 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
